
/*:
 * @target MZ
 *
 * @command Oex_Scene_Battle
 * @desc 
 * @text Oex_Scene_Battle
 *
 * @arg maxLength
 * @type number
 * @min 1
 * @max 10
 * @default 3
 * @text maxLength
 * @desc maxLength
 *
 *
 *
 */

(() => {
    const pluginName = "plugin_Battle";

    PluginManager.registerCommand(pluginName, "Oex_Scene_Battle", args => {
        SceneManager.push(Oex_Scene_Battle);
        //SceneManager.prepareNextScene(0, Number(args.maxLength));
    });

    AudioManager.isPlayMe = function() {
        if (this._meBuffer) {
            return true;
        }
        return false;
    };

    //-----------------------------------------------------------------------------
    // Oex_Window_BattleCommand
    //
    // The window for selecting New Game/Continue on the title screen.

    function Oex_Window_BattleCommand() {
        this.initialize(...arguments);
    }

    Oex_Window_BattleCommand.prototype = Object.create(Window_Command.prototype);
    Oex_Window_BattleCommand.prototype.constructor = Oex_Window_BattleCommand;

    Oex_Window_BattleCommand.prototype.initialize = function(rect) {
        Window_Command.prototype.initialize.call(this, rect);
        this.openness = 0;
    };

    Oex_Window_BattleCommand.initCommandPosition = function() {
    };

    Oex_Window_BattleCommand.prototype.makeCommandList = function() {
        this.addCommand("Back to Battle", "continue");
        this.addCommand("Battle Skip(Success)", "success");
        this.addCommand("Battle Skip(Failure)", "failure");
    };

    Oex_Window_BattleCommand.prototype.processOk = function() {
        Window_Command.prototype.processOk.call(this);
    };

    //-----------------------------------------------------------------------------
    // Oex_Sprite_HpGauge

    function Oex_Sprite_HpGauge() {
        this.initialize(...arguments);
    }
    Oex_Sprite_HpGauge.prototype = Object.create(Sprite_Clickable.prototype);
    Oex_Sprite_HpGauge.prototype.constructor = Oex_Sprite_HpGauge;

    Oex_Sprite_HpGauge.prototype.initialize = function() {
        Sprite_Clickable.prototype.initialize.call(this);
        this.initMembers();
    };

    Oex_Sprite_HpGauge.prototype.initMembers = function() {
        this.createMainSprite();
        this.x = 150;
        this.y = -400; //768 - 40 - 8;
    };

    Oex_Sprite_HpGauge.prototype.createMainSprite = function() {
        this.heart_sprites = [];
        for (let i = 0; i < 16; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture("hearts00");
            sp.y = 30 * Math.floor(i / 8);
            sp.x = 30 * (i % 8);
            sp.setFrame(0, 0, 30, 30);
            this.addChild(sp);
            this.heart_sprites.push(sp);
        }
    };

    Oex_Sprite_HpGauge.prototype.update = function() {
        Sprite_Clickable.prototype.update.call(this);
        var scale = Math.floor($gameVariables.value(3));
        for (let i = 0; i < 16; i++) {
            var sp = this.heart_sprites[i];
            if (i < scale) {
                sp.setFrame(30, 0, 30, 30);
            } else {
                sp.setFrame(0, 0, 30, 30);
            }
        }
    };


    //-----------------------------------------------------------------------------
    // Oex_Sprite_MpGauge

    function Oex_Sprite_MpGauge() {
        this.initialize(...arguments);
    }
    Oex_Sprite_MpGauge.prototype = Object.create(Sprite_Clickable.prototype);
    Oex_Sprite_MpGauge.prototype.constructor = Oex_Sprite_MpGauge;

    Oex_Sprite_MpGauge.prototype.initialize = function(_scene) {
        this._scene = _scene;
        Sprite_Clickable.prototype.initialize.call(this);
        this.initMembers();
    };

    Oex_Sprite_MpGauge.prototype.initMembers = function() {
        this.createMainSprite();
        this.x = -100;
        this.y = -600; //768 - 40 - 8;
    };

    Oex_Sprite_MpGauge.prototype.createMainSprite = function() {
        this.heart_sprites = [];
        for (let i = 0; i < 10; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture("magics00");
            sp.y = 30 * Math.floor(i / 5);
            sp.x = 30 * (i % 5);
            sp.setFrame(0, 0, 30, 30);
            this.addChild(sp);
            this.heart_sprites.push(sp);
        }
    };

    Oex_Sprite_MpGauge.prototype.update = function() {
        Sprite_Clickable.prototype.update.call(this);
        var scale = this._scene._mp_cost;
        for (let i = 0; i < 10; i++) {
            var sp = this.heart_sprites[i];
            if (i < scale) {
                sp.setFrame(30, 0, 30, 30);
            } else {
                sp.setFrame(0, 0, 30, 30);
            }
        }
        if (!this._scene._start_battle) {
            this.visible = false;
        } else {
            this.visible = true;
        }
    };

    //-----------------------------------------------------------------------------
    // Oex_Sprite_ExplainCard

    function Oex_Sprite_ExplainCard() {
        this.initialize(...arguments);
    }
    Oex_Sprite_ExplainCard.prototype = Object.create(Sprite_Clickable.prototype);
    Oex_Sprite_ExplainCard.prototype.constructor = Oex_Sprite_ExplainCard;

    Oex_Sprite_ExplainCard.prototype.initialize = function(_scene) {
        this._scene = _scene;
        this._expids = [0,0,1,2,3,3,4,4,5,5];
        Sprite_Clickable.prototype.initialize.call(this);
        this.initMembers();
    };

    Oex_Sprite_ExplainCard.prototype.initMembers = function() {
        this.x = 0;
        this.y = 0; //768 - 40 - 8;
        this.createMainSprite();
    };

    Oex_Sprite_ExplainCard.prototype.createMainSprite = function() {
        this._mainSprite = new Sprite();
        this._mainSprite.bitmap = ImageManager.loadPicture("explainlabel00");
        this._mainSprite.setFrame(0, 0, 450, 250);
        this.addChild(this._mainSprite);
        this._costSprite = new Sprite();
        this._costSprite.bitmap = ImageManager.loadPicture("costlabel00");
        this._costSprite.setFrame(0, 0, 60, 60);
        this._costSprite.x = 380;
        this._costSprite.y = 10;
        this.addChild(this._costSprite);
        this._alertSprite = new Sprite();
        this._alertSprite.bitmap = ImageManager.loadPicture("costalertl00");
        this._alertSprite.anchor.x = 0;
        this._alertSprite.anchor.y = 1;
        this.addChild(this._alertSprite);
    };

    Oex_Sprite_ExplainCard.prototype.update = function() {
        Sprite_Clickable.prototype.update.call(this);
        if (this._scene._buttonIndex < this._scene.cards.length && this._scene._buttonIndex >= 0) {
            var kind = this._scene.cards[this._scene._buttonIndex];
            var fkind = this._scene.filter_kind(kind);
            var expid = this._expids[fkind];
            if (this._scene._char_index == 0) {
                this._mainSprite.setFrame(450 * (expid % 3), 250 * Math.floor(expid / 3), 450, 250);
            } else {
                this._mainSprite.setFrame(450 * (expid % 3), 250 * Math.floor(expid / 3) + 500, 450, 250);
            }
            var _cost = this._scene.mp_cost(kind);
            this._costSprite.setFrame(60 * (_cost % 5), 60 * Math.floor(_cost / 5), 60, 60);
            if (_cost > this._scene._mp_cost) {
                this._alertSprite.visible = true;
            } else {
                this._alertSprite.visible = false;
            }
            if (this._scene._buttonIndex < 4) {
                this.x = 150 + 75 * 4;
                this.y = 400;
            } else {
                this.x = 150 + 75 * 0;
                this.y = 400;
            }
            this.visible = true;
        } else {
            this.visible = false;
        }
        this.scale.x = 0.75;
        this.scale.y = 0.75;
        if (!this._scene._start_battle) {
            this.visible = false;
        }
    };

    //-----------------------------------------------------------------------------
    // Oex_Sprite_BCard

    function Oex_Sprite_BCard() {
        this.initialize(...arguments);
    }
    Oex_Sprite_BCard.prototype = Object.create(Sprite_Clickable.prototype);
    Oex_Sprite_BCard.prototype.constructor = Oex_Sprite_BCard;

    Oex_Sprite_BCard.prototype.initialize = function(_scene, _card_index) {
        this._scene = _scene;
        this._card_index = _card_index;
        Sprite_Clickable.prototype.initialize.call(this);
        this.initMembers();
    };

    Oex_Sprite_BCard.prototype.initMembers = function() {
        this.x = 0;
        this.y = -100; //768 - 40 - 8;
        this.createMainSprite();
    };

    Oex_Sprite_BCard.prototype.createMainSprite = function() {
        this.bitmap = new Bitmap(75, 100);
        this._mainSprite = new Sprite();
        this._mainSprite.bitmap = ImageManager.loadPicture("cardmage00");
        this._mainSprite.setFrame(0, 0, 150, 210);
        this._mainSprite.scale.x = 0.5;
        this._mainSprite.scale.y = 0.5;
        this.addChild(this._mainSprite);
        this._costSprite = new Sprite();
        this._costSprite.bitmap = ImageManager.loadPicture("costlabel00");
        this._costSprite.setFrame(0, 0, 60, 60);
        this._costSprite.scale.x = 0.5;
        this._costSprite.scale.y = 0.5;
        this._costSprite.x = 42;
        this._costSprite.y = 4;
        this.addChild(this._costSprite);
    };

    Oex_Sprite_BCard.prototype.update = function() {
        Sprite_Clickable.prototype.update.call(this);
        if (this._card_index < this._scene.cards.length) {
            var kind = this._scene.cards[this._card_index];
            var fkind = this._scene.filter_kind(kind);
            if (this._scene._char_index == 0) {
                this._mainSprite.setFrame(150 * fkind,   0, 150, 210);
            } else {
                this._mainSprite.setFrame(150 * fkind, 210, 150, 210);
            }
            var _cost = this._scene.mp_cost(kind);
            this._costSprite.setFrame(60 * (_cost % 5), 60 * Math.floor(_cost / 5), 60, 60);
            this.x = 150 + 75 * this._card_index;
            this.y = 630;
            if (this._scene._buttonIndex == this._card_index) {
                //this.y = 450;
                this.visible = false;
            } else {
                this.visible = true;
            }
        } else {
            this.visible = false;
        }
        if (!this._scene._start_battle) {
            this.visible = false;
        }
    };

    Oex_Sprite_BCard.prototype.selectCard = function() {
        //if (this._scene._buttonIndex == this._card_index) {
        //    this._scene.executeButton();
        //} else {
        //    SoundManager.playCursor();
        //    this._scene._buttonIndex = this._card_index;
        //}
    };

    Oex_Sprite_BCard.prototype.onClick = function() {
        if (this._scene._buttonIndex == this._card_index) {
        } else {
            SoundManager.playCursor();
            this._scene._buttonIndex = this._card_index;
        }
    };

    //-----------------------------------------------------------------------------
    // Oex_Sprite_SelectedCard

    function Oex_Sprite_SelectedCard() {
        this.initialize(...arguments);
    }
    Oex_Sprite_SelectedCard.prototype = Object.create(Sprite_Movable.prototype);
    Oex_Sprite_SelectedCard.prototype.constructor = Oex_Sprite_SelectedCard;

    Oex_Sprite_SelectedCard.prototype.initialize = function(_scene) {
        this._scene = _scene;
        Sprite_Movable.prototype.initialize.call(this);
        this.initMembers();
    };

    Oex_Sprite_SelectedCard.prototype.initMembers = function() {
        this.x = 0;
        this.y = -100; //768 - 40 - 8;
        this.createMainSprite();
    };

    Oex_Sprite_SelectedCard.prototype.createMainSprite = function() {
        this.bitmap = new Bitmap(150, 210);
        this._mainSprite = new Sprite();
        this._mainSprite.bitmap = ImageManager.loadPicture("cardmage00");
        this._mainSprite.setFrame(0, 0, 150, 210);
        this.addChild(this._mainSprite);
        this._costSprite = new Sprite();
        this._costSprite.bitmap = ImageManager.loadPicture("costlabel00");
        this._costSprite.setFrame(0, 0, 60, 60);
        this._costSprite.scale.x = 1.0;
        this._costSprite.scale.y = 1.0;
        this._costSprite.x = 85;
        this._costSprite.y = 4;
        this.addChild(this._costSprite);
    };

    Oex_Sprite_SelectedCard.prototype.update = function() {
        Sprite_Movable.prototype.update.call(this);
        if (this.isEffecting()) {
            return;
        }
        if (this._scene._buttonIndex < this._scene.cards.length && this._scene._buttonIndex >= 0) {
            var kind = this._scene.cards[this._scene._buttonIndex];
            var fkind = this._scene.filter_kind(kind);
            if (this._scene._char_index == 0) {
                this._mainSprite.setFrame(150 * fkind,   0, 150, 210);
            } else {
                this._mainSprite.setFrame(150 * fkind, 210, 150, 210);
            }
            var _cost = this._scene.mp_cost(kind);
            this._costSprite.setFrame(60 * (_cost % 5), 60 * Math.floor(_cost / 5), 60, 60);
            if (!this._pressed) {
                this.x = 150 + 75 * this._scene._buttonIndex;
                this.y = 500;
            }
            this.visible = true;
        } else {
            this.visible = false;
            this.scale.x = 1.0;
            this.scale.y = 1.0;
            this.opacity = 255;
        }
        if (!this._scene._start_battle) {
            this.visible = false;
        }
    };

    Oex_Sprite_SelectedCard.prototype.processTouchMove = function() {
        if (this.isMoveEnabled()) {
            if (!this._tmp_press && this._pressed) {
                this._lastX = TouchInput.x;
                this._lastY = TouchInput.y;
            }
            if (this._pressed && TouchInput.isMoved()) {
                this.onMoved(TouchInput.x - this._lastX, TouchInput.y - this._lastY);
                this._lastX = TouchInput.x;
                this._lastY = TouchInput.y;
            }
            this._tmp_press = this._pressed;
        } else {
            this._tmp_press = false;
        }
    };

    Oex_Sprite_SelectedCard.prototype.onMoved = function(_slipX, _slipY) {
        this.x += _slipX;
        this.y += _slipY;
    };

    Oex_Sprite_SelectedCard.prototype.onClick = function() {
        if (this.y <= 400) {
            this._scene.executeButton();
        }
    };

    //-----------------------------------------------------------------------------
    // Oex_Scene_Battle
    //
    // The superclass of all the menu-type scenes.

    function Oex_Scene_Battle() {
        this.initialize(...arguments);
    }

    Oex_Scene_Battle.prototype = Object.create(Scene_Message.prototype);
    Oex_Scene_Battle.prototype.constructor = Oex_Scene_Battle;

    Oex_Scene_Battle.prototype.initialize = function() {
        Scene_Message.prototype.initialize.call(this);
    };

    Oex_Scene_Battle.prototype.create = function() {
        Scene_Message.prototype.create.call(this);
        this._start_battle = false;
        this._phase = 0; // 0:battle 1:message 2:effect
        this._eventPahse = 0;
        this._index = 0;
        this._char_index = 0;
        this._buttonIndex = 0;
        this._commands = [];
        this._commands.push({ "kind" : "game_start"});
        this._enemyataccking = false;
        this._all_h1 = false;
        this._all_h3 = false;
        this._cost_m2 = false;
        this._cost_d2 = false;
        this._card_used_num = 0;
        this._mp_cost = 10;
        $gameVariables.setValue(3, 0);
        $gameSwitches.setValue(12, false);
        this.cards = [1,2,3,4,5,6,7,8,9];
        this.createBackground();
        this.createButtons();
        this.createWindowLayer();
        this.createAllWindows();
        this.createCommandWindow();
        this.createCancelButton();
        OexUtils.playBGM("VNM1_BGM10_Angry_Comical");
        DataManager.addSystemdInfo("__enemy01");
    };

    Oex_Scene_Battle.prototype.update = function() {
        Scene_Message.prototype.update.call(this);
        this.updatePhase();
        this.updateCommands();
        switch (this._phase) {
            case 0:
                if (Input.isTriggered("right")) {
                    if (this._buttonIndex < this.cards.length - 1) {
                        this._buttonIndex += 1;
                        SoundManager.playCursor();
                    }
                }
                if (Input.isTriggered("left")) {
                    if (this._buttonIndex > 0) {
                        this._buttonIndex -= 1;
                        SoundManager.playCursor();
                    }
                }
                if (Input.isTriggered("tab")) {
                    this.clickTab();
                }
                if (Input.isTriggered("ok")) {
                    this.executeButton();
                }
                if (Input.isRepeated("cancel") || TouchInput.isCancelled() || Input.isTriggered("menu")) {
                    SoundManager.playCancel();
                    this._commandWindow.open();
                    this._commandWindow.activate();
                }
                break;
            case 1:
                break;
            case 2:
                break;
        }
        if (this._enemyataccking) {
            this.enemy_sp.y = 540;
        } else {
            this.enemy_sp.y = 550;
        }
        if (this.h10_sp) {
            if (this._phase == 0) {
                this.h10_sp.visible = true;
            } else {
                this.h10_sp.visible = false;
            }
        }
        
    };

    Oex_Scene_Battle.prototype.clickTab = function() {
        OexUtils.playSound("__card_turn00");
        if (this._char_index == 0) {
            this._char_index = 1;
            this._standSprite01.bitmap = ImageManager.loadPicture("h2_06"); // h2_06
        } else {
            this._char_index = 0;
            this._standSprite01.bitmap = ImageManager.loadPicture("h1_04"); // h2_06
        }
    };

    Oex_Scene_Battle.prototype.mp_cost = function(kind) {
        var base = this.mp_cost_base(kind);
        if (this._cost_m2) {
            base -= 1;
            if (base < 0) {
                base = 0;
            }
        } else if (this._cost_d2) {
            base = Math.ceil(base / 2.0);
        }
        return base;
    };

    Oex_Scene_Battle.prototype.filter_kind = function(kind) {
        if (kind >= 4) {
            if (this._all_h1) {
                return 4;
            } else if (this._all_h3) {
                return 8;
            }
        }
        return kind;
    };

    Oex_Scene_Battle.prototype.mp_cost_base = function(kind) {
        switch (kind) {
            case 1: // MP+X Xはこれまでに使用したカード枚数
              return 0;
            case 2: // すべてのカードのMP-2/すべてのカードのMP/2（切り上げ)
              return 1;
            case 3: // すべてを説得+1に/すべてを説得+3に
              return 0;
            case 4: // 説得+1
              if (this._all_h1) {
                  return 2;
              } else if (this._all_h3) {
                  return 6;
              }
              return 2;
            case 5: // 説得+1
              if (this._all_h1) {
                  return 2;
              } else if (this._all_h3) {
                  return 6;
              }
              return 2;
            case 6: // 説得+2
              if (this._all_h1) {
                  return 2;
              } else if (this._all_h3) {
                  return 6;
              }
              return 4;
            case 7: // 説得+2
              if (this._all_h1) {
                  return 2;
              } else if (this._all_h3) {
                  return 6;
              }
              return 4;
            case 8: // 説得+3
              if (this._all_h1) {
                  return 2;
              } else if (this._all_h3) {
                  return 6;
              }
              return 6;
            case 9: // 説得+3
              if (this._all_h1) {
                  return 2;
              } else if (this._all_h3) {
                  return 6;
              }
              return 6;
        }
    };

    Oex_Scene_Battle.prototype.executeCard = function(kind) {
        var mp = this.mp_cost(kind);
        if (mp <= this._mp_cost) {
            
        } else {
            return;
        }
        this._mp_cost -= mp;
        switch (kind) {
            case 1: // MP回復(最大値を超えない)
                if (this._char_index == 0) {
                    this._mp_cost += this._card_used_num;
                    if (this._mp_cost > 10) {
                        this._mp_cost = 10;
                    }
                } else {
                    var ht = $gameVariables.value(3);
                    ht += this._card_used_num;
                    $gameVariables.setValue(3, ht);
                }
                this._card_used_num += 1;
                break;
            case 2: // すべてのカードのMP-2/すべてのカードのMP/2（切り上げ)
                if (this._char_index == 0) {
                    this._cost_m2 = false;
                    this._cost_d2 = true;
                } else {
                    this._cost_m2 = true;
                    this._cost_d2 = false;
                }
                this._card_used_num += 1;
                break;
            case 3: // すべてを説得+1に/すべてを説得+3に
                if (this._char_index == 0) {
                    this._all_h1 = true;
                    this._all_h3 = false;
                } else {
                    this._all_h1 = false;
                    this._all_h3 = true;
                }
                this._card_used_num += 1;
                break;
            case 4: // 説得+1
                this.executeH1();
                this._card_used_num += 1;
                break;
            case 5: // 説得+1
                this.executeH1();
                this._card_used_num += 1;
                break;
            case 6: // 説得+2
                this.executeH2();
                this._card_used_num += 1;
                break;
            case 7: // 説得+2
                this.executeH2();
                this._card_used_num += 1;
                break;
            case 8: // 説得+3
                this.executeH3();
                this._card_used_num += 1;
                break;
            case 9: // 説得+3
                this.executeH3();
                this._card_used_num += 1;
                break;
        }
        var kindex = this.cards.indexOf(kind);
        if (kindex !== -1) {
            this.cards.splice(kindex, 1);
        }
    };

    Oex_Scene_Battle.prototype.executeH1 = function() {
        if (this._all_h1) {
        } else if (this._all_h3) {
            this.executeH3();
            return;
        }
        var ht = $gameVariables.value(3);
        ht += 1;
        $gameVariables.setValue(3, ht);
        if (this._char_index == 0) {
            this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "Calm down.", "background" : 0, "position" : 2  });
            this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "................", "background" : 0, "position" : 0 });
        } else {
            this._commands.push({ "kind" : "message", "name" : "\\n[2]", "text" : "You should calm down.", "background" : 0, "position" : 2  });
            this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "................", "background" : 0, "position" : 0 });
        }
    };

    Oex_Scene_Battle.prototype.executeH2 = function() {
        if (this._all_h1) {
            this.executeH1();
            return;
        } else if (this._all_h3) {
            this.executeH3();
            return;
        }
        var ht = $gameVariables.value(3);
        ht += 2;
        $gameVariables.setValue(3, ht);
        if (this._char_index == 0) {
            this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "Hey, listen to me.", "background" : 0, "position" : 2  });
            this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "................", "background" : 0, "position" : 0 });
        } else {
            this._commands.push({ "kind" : "message", "name" : "\\n[2]", "text" : "Listen to what I have to say.", "background" : 0, "position" : 2  });
            this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "................", "background" : 0, "position" : 0 });
        }
    };

    Oex_Scene_Battle.prototype.executeH3 = function() {
        if (this._all_h1) {
            this.executeH1();
            return;
        } else if (this._all_h3) {
        }
        var ht = $gameVariables.value(3);
        ht += 3;
        $gameVariables.setValue(3, ht);
        if (this._char_index == 0) {
            this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "Don't blame yourself!", "background" : 0, "position" : 2  });
            this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "................", "background" : 0, "position" : 0 });
        } else {
            this._commands.push({ "kind" : "message", "name" : "\\n[2]", "text" : "You should have confidence in yourself.", "background" : 0, "position" : 2  });
            this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "................", "background" : 0, "position" : 0 });
        }
    };

    Oex_Scene_Battle.prototype.updateCommands = function() {
        if (this._phase != 0) {
            return;
        }
        if (this._commands.length > 0) {
            const command = this._commands.shift();
            switch (command.kind) {
                case "game_start":
                    this.updateEvent();
                    break;
                case "start_battle":
                    this._start_battle = true;
                    this.h10_sp = new Sprite();
                    this.h10_sp.bitmap = ImageManager.loadPicture("winh10");
                    this.h10_sp.x = 0;
                    this.h10_sp.y = 0;
                    this.addChild(this.h10_sp);
                    break;
                case "check_event":
                    this.updateEvent();
                    break;
                case "player1_attack":
                    this.enemy_anime_sp.initMembers();
                    this.enemy_anime_sp.setup([this.enemy_sp], $dataAnimations[11], false, 12, null);
                    break;
                case "player1_defense":
                    this.player1_anime_sp.initMembers();
                    this.player1_anime_sp.setup([this._standSprite01], $dataAnimations[10], false, 12, null);
                    break;
                case "enemy_attack":
                    this._enemyataccking = true;
                    OexUtils.playSound("Attack1");
                    this.player1_anime_sp.initMembers();
                    this.player1_anime_sp.setup([this._standSprite01], $dataAnimations[11], false, 60, null);
                    break;
                case "player_damage":
                    var nyoi = $gameVariables.value(4);
                    nyoi += Number(command.damage);
                    $gameVariables.setValue(4, nyoi);
                    this.updateEvent();
                    this._enemyataccking = false;
                    break;
                case "enemy_damage":
                    var nyoi = $gameVariables.value(3);
                    nyoi += Number(command.damage);
                    $gameVariables.setValue(3, nyoi);
                    this.updateEvent();
                    this.enemyAction();
                    break;
                case "card_use":
                    var card_kind = Number(command.card_kind);
                    this.executeCard(card_kind);
                    this.updateEvent();
                    this.enemyAction();
                    break;
                case "player1_defense_execute":
                    this.enemyAction();
                    break;
                case "enemy_dispose":
                    this.enemy_sp.startDisappear();
                    OexUtils.playSound("Saint4");
                    break;
                case "start_select":
                    this._buttonIndex = 0;
                    break;
                case "popScene":
                    this.popScene();
                    break;
                case "message":
                    // $gameMessage.setSpeakerName("\\n[1]");"background" : 0, "position" : 0
                    $gameMessage.setBackground(command.background);
                    $gameMessage.setPositionType(command.position);
                    $gameMessage.setSpeakerName(command.name);
                    $gameMessage.add(command.text);
                    break;
                case "defeat_me":
                    AudioManager.playMe($gameSystem.defeatMe());
                    var sp = new Sprite();
                    sp.bitmap = ImageManager.loadPicture("battle_result00");
                    sp.anchor.x = 0.5;
                    sp.anchor.y = 0.5;
                    sp.x = Graphics.boxWidth / 2;
                    sp.y = Graphics.boxHeight / 2;
                    this.addChild(sp);
                    break;
                case "win_me":
                    AudioManager.playMe($gameSystem.victoryMe());
                    var sp = new Sprite();
                    sp.bitmap = ImageManager.loadPicture("battle_result01");
                    sp.anchor.x = 0.5;
                    sp.anchor.y = 0.5;
                    sp.x = Graphics.boxWidth / 2;
                    sp.y = Graphics.boxHeight / 2;
                    this.addChild(sp);
                    break;
            }
            this.updatePhase();
        }
    };

    Oex_Scene_Battle.prototype.updatePhase = function() {
        if ($gameMessage.hasText() || !(this._messageWindow.visible == false || this.isMessageWindowClosing() || this._messageWindow.isClosed())) {
            this._phase = 1;
        } else if (this.isEffecting()) {
            this._phase = 2;
        } else {
            this._phase = 0;
        }
    };

    Oex_Scene_Battle.prototype.isEffecting = function() {
        return (this.enemy_sp.isEffecting() || this._standSprite01.isEffecting() ||  this.enemy_anime_sp.isPlaying() ||  this.player1_anime_sp.isPlaying()
                || this._selected_card_sp.isEffecting() || AudioManager.isPlayMe() || this._commandWindow.active);
    };

    Oex_Scene_Battle.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    Oex_Scene_Battle.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    Oex_Scene_Battle.prototype.createButtons = function() {
        this.enemy_sp = new Sprite();
        this.enemy_sp.bitmap = ImageManager.loadPicture("__enemy01");
        this.enemy_sp.x = 500;
        this.enemy_sp.y = 550;
        this.enemy_sp.anchor.x = 0.5;
        this.enemy_sp.anchor.y = 1;
        this.addChild(this.enemy_sp);
        
        this._hpGaugeSprite = new Oex_Sprite_HpGauge();
        this.enemy_sp.addChild(this._hpGaugeSprite);

        this.enemy_anime_sp = new Sprite_Animation();
        this.addChild(this.enemy_anime_sp);

        this._standSprite01 = new Sprite();
        this._standSprite01.bitmap = ImageManager.loadPicture("h1_04"); // h2_06
        this._standSprite01.anchor.x = 0.5;
        this._standSprite01.anchor.y = 1;
        this._standSprite01.x = 150;
        this._standSprite01.y = 720;
        this.addChild(this._standSprite01);
        
        this._mpGaugeSprite = new Oex_Sprite_MpGauge(this);
        this._standSprite01.addChild(this._mpGaugeSprite);

        this.player1_anime_sp = new Sprite_Animation();
        this.addChild(this.player1_anime_sp);

        this._selected_card_sp = new Oex_Sprite_SelectedCard(this);
        this.addChild(this._selected_card_sp);
        
        this.card_sprites = [];
        for (let i = 0; i < 9; i++) {
            var sp = new Oex_Sprite_BCard(this, i);
            this.addChild(sp);
            this.card_sprites.push(sp);
        }
        this._exlpain_sp = new Oex_Sprite_ExplainCard(this);
        this.addChild(this._exlpain_sp);
        
        this._change_sp = new OexSprite_CommonButton("char_change00", new Rectangle(0, 0, 150, 50), new Rectangle(0, 0, 150, 50));
        this._change_sp.x = 20;
        this._change_sp.y = 400;
        this._change_sp.setClickHandler(this.clickTab.bind(this));
        this.addChild(this._change_sp);

        // this._attack = new OexSprite_CommonButton("manu_button00", new Rectangle(0, 0, 96, 48), new Rectangle(0, 0, 96, 48));
        // this._attack.x = Graphics.boxWidth / 2 - 100;
        // this._attack.y = 550;
        // this._attack.anchor.x = 0.5;
        // this._attack.anchor.y = 0.5;
        // this._attack.setClickHandler(this.attackButton.bind(this));
        // this.addChild(this._attack);
        
        // this._defense = new OexSprite_CommonButton("manu_button00", new Rectangle(96, 0, 96, 48), new Rectangle(96, 0, 96, 48));
        // this._defense.x = Graphics.boxWidth / 2 + 100;
        // this._defense.y = 550;
        // this._defense.anchor.x = 0.5;
        // this._defense.anchor.y = 0.5;
        // this._defense.setClickHandler(this.defenseButton.bind(this));
        // this.addChild(this._defense);
        
        // this._nyoGaugeSprite = new Oex_Sprite_NyoGauge();
        // this.addChild(this._nyoGaugeSprite);
        // this._nyoGaugeSprite.y = Graphics.boxHeight - 40;
        //this.finger_sp = new Sprite();
        //this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        //this.addChild(this.finger_sp);
    };

    Oex_Scene_Battle.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("menu");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    Oex_Scene_Battle.prototype.createCommandWindow = function() {
        const rect = this.commandWindowRect();
        this._commandWindow = new Oex_Window_BattleCommand(rect);
        this._commandWindow.setHandler("continue", this.commandContinue.bind(this));
        this._commandWindow.setHandler("success", this.commandSuccess.bind(this));
        this._commandWindow.setHandler("failure", this.commandFailure.bind(this));
        this.addWindow(this._commandWindow);
        this._commandWindow.close();
        this._commandWindow.deactivate();
    };

    Oex_Scene_Battle.prototype.commandContinue = function() {
        this._commandWindow.close();
        this._commandWindow.deactivate();
    };

    Oex_Scene_Battle.prototype.commandSuccess = function() {
        this._commandWindow.close();
        this._commandWindow.deactivate();
        this._eventPahse = 3;
        this._commands.push({ "kind" : "check_event"});
    };

    Oex_Scene_Battle.prototype.commandFailure = function() {
        this._commandWindow.close();
        this._commandWindow.deactivate();
        this._eventPahse = 5;
        this._commands.push({ "kind" : "check_event"});
    };

    Oex_Scene_Battle.prototype.commandWindowRect = function() {
        const offsetX = $dataSystem.titleCommandWindow.offsetX;
        const offsetY = $dataSystem.titleCommandWindow.offsetY;
        const ww = 360;
        const wh = this.calcWindowHeight(3, true);
        const wx = (Graphics.boxWidth - ww) / 2 + offsetX;
        const wy = Graphics.boxHeight - wh - 96 - 96 + offsetY;
        return new Rectangle(wx, wy, ww, wh);
    };

    Oex_Scene_Battle.prototype.createAnimationSprite = function(
        targets, animation, mirror, delay
    ) {
        const mv = this.isMVAnimation(animation);
        const sprite = new (mv ? Sprite_AnimationMV : Sprite_Animation)();
        const targetSprites = this.makeTargetSprites(targets);
        const baseDelay = this.animationBaseDelay();
        const previous = delay > baseDelay ? this.lastAnimationSprite() : null;
        if (this.animationShouldMirror(targets[0])) {
            mirror = !mirror;
        }
        sprite.targetObjects = targets;
        sprite.setup(targetSprites, animation, mirror, delay, previous);
        this._effectsContainer.addChild(sprite);
        this._animationSprites.push(sprite);
    };

    Oex_Scene_Battle.prototype.attackButton = function() {
        OexUtils.playSound("__button45");
        if (this._buttonIndex == 0) {
            this.executeButton();
        } else {
            this._buttonIndex = 0;
        }
    };

    Oex_Scene_Battle.prototype.defenseButton = function() {
        OexUtils.playSound("__button45");
        if (this._buttonIndex == 1) {
            this.executeButton();
        } else {
            this._buttonIndex = 1;
        }
    };

    Oex_Scene_Battle.prototype.executeButton = function() {
        if (this._phase != 0) {
            return;
        }
        if (this._buttonIndex < this.cards.length) {
            var mp = this.mp_cost(this.cards[this._buttonIndex]);
            if (mp <= this._mp_cost) {
                
            } else {
                return;
            }
            OexUtils.playSound("__button02");
            this._selected_card_sp.startTransform(10, [500, 300], [0.34, 0.34], 0, 0.0, 0);
            this._commands.push({ "kind" : "player1_attack"});
            this._commands.push({ "kind" : "card_use", "card_kind" : this.cards[this._buttonIndex] });
        }
    };

    Oex_Scene_Battle.prototype.enemyAction = function() {
        this._buttonIndex = -1;
        this._commands.push({ "kind" : "start_select"});
        //this._commands.push({ "kind" : "enemy_attack"});
        //this._commands.push({ "kind" : "player_damage", "damage" : Math.floor(Number(140).fluctuate(50)) });
    };

    // 0:continue 1:win 2:lose
    Oex_Scene_Battle.prototype.checkEnd = function() {
        var _hp = $gameVariables.value(3);
        if (_hp >= 16) {
            return 1;
        }
        for (const kind of this.cards) {
            var mp = this.mp_cost(kind);
            if (this._mp_cost >= mp) {
                return 0;
            }
        }
        return 2;
    };

    Oex_Scene_Battle.prototype.updateEvent = function() {
        if (this._eventPahse < 9) {
            var check_result = this.checkEnd();
            if (check_result == 0) {
            } else if (check_result == 1) {
                this._eventPahse = 3;
            } else if (check_result == 2) {
                this._eventPahse = 5;
            }
        }
        switch(this._eventPahse) {
            case 0:
                this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "I'll be weird, I'll be weird, I'll be weird, I'll be weird, I'll be weird...", "background" : 0, "position" : 0 });
                this._commands.push({ "kind" : "message", "name" : "\\n[2]", "text" : "What's going on?", "background" : 0, "position" : 2  });
                this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "\\n[5]'s mind is falling apart.", "background" : 0, "position" : 2  });
                this._commands.push({ "kind" : "message", "name" : "\\n[2]", "text" : "This is bad, we need to do something!", "background" : 0, "position" : 2  });
                this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "It's okay, in times like this...", "background" : 0, "position" : 2  });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "The subject's mind is in a state of chaos.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "You can stop the subject's chaos by filling \\i[2] at the bottom right to its maximum.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "You can take actions using cards.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "By using cards from your hand, you can fill \\i[2].", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "To use a card, you need to spend \\i[4].", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "Card flipping", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "During battle, you can flip cards by pressing the tab key or the 'Change' button.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "Some cards have different effects when flipped.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "The battle will end when \\i[2] is filled to its maximum or when you run out of usable cards.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "", "text" : "You can also skip the battle by pressing Esc or the icon in the top right.", "background" : 1, "position" : 1 });
                this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "Alright, let's do our best!", "background" : 0, "position" : 2  });
                this._commands.push({ "kind" : "start_battle"});
                this._eventPahse += 1;
                break;
            case 1:
                var _hp = $gameVariables.value(3);
                if (_hp >= 8) {
                    this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "No matter how much time passes, my bedwetting won't stop.", "background" : 0, "position" : 0 });
                    this._commands.push({ "kind" : "message", "name" : "\\n[5]", "text" : "At this rate, I won't be able to confess to \\n[7].", "background" : 0, "position" : 0 });
                    this._commands.push({ "kind" : "message", "name" : "\\n[2]", "text" : "She's losing confidence because she's too worried about the bedwetting.", "background" : 0, "position" : 2  });
                    this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "What should we do...?", "background" : 0, "position" : 2  });
                    this._eventPahse += 1;
                }
                break;
            case 2:
                break;
            case 3: // win
                    this._commands.push({ "kind" : "enemy_dispose"});
                    this._commands.push({ "kind" : "win_me"});
                    this._commands.push({ "kind" : "popScene"});
                    $gameSwitches.setValue(12, true);
                    this._eventPahse = 9;
                break;
            case 4:
                break;
            case 5: // lose
                    this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "I don't have a card I can use anymore.", "background" : 0, "position" : 2  });
                    this._commands.push({ "kind" : "message", "name" : "\\n[1]", "text" : "I failed to convince her.", "background" : 0, "position" : 2  });
                    this._commands.push({ "kind" : "defeat_me"});
                    this._commands.push({ "kind" : "popScene"});
                    $gameSwitches.setValue(12, false);
                    this._eventPahse = 9;
                break;
            case 9:
                break;
        }
    };
        
        // 
        // 
        // 
        // 

Scene_Battle = Oex_Scene_Battle;

})();
