
/*:
 * @target MZ
 *
 * @command OexScene_Ex1
 * @desc 
 * @text OexScene_Ex1
 *
 * @command OexScene_Ex2
 * @desc 
 * @text OexScene_Ex2
 *
 * @command OexScene_Ex3
 * @desc 
 * @text OexScene_Ex3
 *
 * @command OexScene_Ex4
 * @desc 
 * @text OexScene_Ex4
 *
 * @command OexScene_Ex5
 * @desc 
 * @text OexScene_Ex5
 *
 * @command OexScene_Ex8
 * @desc 
 * @text OexScene_Ex8
 *
 * @command OexScene_Pass
 * @desc 
 * @text OexScene_Pass
 *
 * @arg maxLength
 * @type number
 * @min 1
 * @max 10
 * @default 3
 * @text maxLength
 * @desc maxLength
 *
 * @command OexScene_PassJa
 * @desc 
 * @text OexScene_PassJa
 *
 * @arg maxLength
 * @type number
 * @min 1
 * @max 10
 * @default 3
 * @text maxLength
 * @desc maxLength
 *
 *
 */

(() => {
    const pluginName = "plugin_ExScene";

    PluginManager.registerCommand(pluginName, "OexScene_Ex1", args => {
        SceneManager.push(OexScene_Ex1);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex2", args => {
        SceneManager.push(OexScene_Ex2);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex3", args => {
        SceneManager.push(OexScene_Ex3);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex4", args => {
        SceneManager.push(OexScene_Ex4);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex5", args => {
        SceneManager.push(OexScene_Ex5);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Ex8", args => {
        SceneManager.push(OexScene_Ex8);
    });
    PluginManager.registerCommand(pluginName, "OexScene_Pass", args => {
        SceneManager.push(OexScene_Pass);
        SceneManager.prepareNextScene(0, Number(args.maxLength));
    });
    PluginManager.registerCommand(pluginName, "OexScene_PassJa", args => {
        SceneManager.push(OexScene_PassJa);
        SceneManager.prepareNextScene(0, Number(args.maxLength));
    });

    //-----------------------------------------------------------------------------
    // OexSprite_Monitor1
    //
    // The sprite class with click handling functions.

    function OexSprite_Monitor1() {
        this.initialize(...arguments);
    }

    OexSprite_Monitor1.prototype = Object.create(Sprite.prototype);
    OexSprite_Monitor1.prototype.constructor = OexSprite_Monitor1;

    OexSprite_Monitor1.prototype.initialize = function() {
        Sprite.prototype.initialize.call(this);
        this._state = [0,0,0,0,0,0];
        this._old_state = [0,0,0,0,0,0];
        this._status_sprites = [];
        this.bitmap = ImageManager.loadPicture("color_monitor00");
        for (let i = 0; i < 6; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture("color_points00");
            sp.setFrame(0, 0, 70, 70);
            sp.y = 21;
            sp.x = 41 + i * 90;
            sp.visible = false;
            this.addChild(sp);
            this._status_sprites.push(sp);
        }
    };

    OexSprite_Monitor1.prototype.update = function() {
        Sprite.prototype.update.call(this);
        for (let i = 0; i < 6; i++) {
            if (this._old_state[i] != this._state[i]) {
                var sp = this._status_sprites[i];
                if (this._state[i] > 0) {
                    sp.setFrame(70 * (this._state[i] - 1), 0, 70, 70);
                    sp.visible = true;
                } else {
                    sp.visible = false;
                }
            }
            this._old_state[i] = this._state[i];
        }
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex1
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex1() {
        this.initialize(...arguments);
    }

    OexScene_Ex1.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex1.prototype.constructor = OexScene_Ex1;

    OexScene_Ex1.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex1.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._index = 0;
        this._buttonIndex = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex1.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex += 3;
            SoundManager.playCursor();
        }
        this._buttonIndex = this._buttonIndex % 4;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex + 1);
        }
        this.finger_sp.x = Graphics.boxWidth / 2 - 230 + 30 + 120 * this._buttonIndex;
        this.finger_sp.y = 400 + 50;
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex1.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex1.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex1.prototype.createButtons = function() {
        this.monitor_sp = new OexSprite_Monitor1();
        this.monitor_sp.x = Graphics.boxWidth / 2 - 320;
        this.monitor_sp.y = 200;
        this.addChild(this.monitor_sp);
        for (let i = 0; i < 4; i++) {
            const ci = (i + 1);
            var sp = new OexSprite_CommonButton("color_buttons00", new Rectangle(100 * i, 0, 100, 100), new Rectangle(100 * i, 100, 100, 100));
            sp.x = Graphics.boxWidth / 2 - 230 + 120 * i;
            sp.y = 400;
            sp.setClickHandler(this.pushButton.bind(this, ci));
            this.addChild(sp);
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex1.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex1.prototype.pushButton = function(color) {
        if (this._index < 6) {
            this._buttonIndex = color - 1;
            this.monitor_sp._state[this._index] = color;
            this._index += 1;
            OexUtils.playSound("__button45");
            if (this._index >= 6) {
                if (JSON.stringify(this.monitor_sp._state) == JSON.stringify([2,3,4,2,1,3])) {
                    OexUtils.playSound("__button02");
                    $gameSwitches.setValue(113, true);
                }
                this.addLazy(60, this.popScene.bind(this));
            }
        }
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex2
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex2() {
        this.initialize(...arguments);
    }

    OexScene_Ex2.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex2.prototype.constructor = OexScene_Ex2;

    OexScene_Ex2.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex2.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndex = 0;
        this._scores = [];
        this._selist = ["piano_do", "piano_re", "piano_mi", "piano_fa", "piano_so", "piano_la", "piano_si", "piano_do2"];
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex2.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        this._buttonIndex = (this._buttonIndex + 8) % 8;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
            this.red_sp.x = Graphics.boxWidth / 2 - 320 + 80 * this._buttonIndex;
            this.red_sp.y = Graphics.boxHeight / 2 - 160;
        }
        if (Input.isPressed("ok")) {
            this.red_sp.visible = true;
        } else {
            this.red_sp.visible = false;
        }
        
        this.finger_sp.x = Graphics.boxWidth / 2 - 320 + 80 * this._buttonIndex;
        this.finger_sp.y = Graphics.boxHeight / 2 + 140;
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex2.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex2.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex2.prototype.createButtons = function() {
        this._pianosp = [];
        for (let i = 0; i < 8; i++) {
            const ci = (i);
            var sp = new OexSprite_CommonButton("piano_white00", new Rectangle(0, 0, 80, 320), new Rectangle(80, 0, 80, 320));
            sp.x = Graphics.boxWidth / 2 - 320 + 80 * i;
            sp.y = Graphics.boxHeight / 2 - 160;
            sp.setClickHandler(this.pushButton.bind(this, ci));
            this.addChild(sp);
            this._pianosp.push(sp);
        }
        this.red_sp = new Sprite();
        this.red_sp.bitmap = ImageManager.loadPicture("piano_red00");
        this.red_sp.x = Graphics.boxWidth / 2 - 320;
        this.red_sp.y = Graphics.boxHeight / 2 - 160;
        this.addChild(this.red_sp);
        for (let i = 0; i < 7; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture("piano_black00");
            sp.x = Graphics.boxWidth / 2 - 320 + 80 * i + 60;
            sp.y = Graphics.boxHeight / 2 - 160;
            this.addChild(sp);
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex2.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex2.prototype.setButtonIndex = function(_index) {
        this._buttonIndex = _index;
    };

    OexScene_Ex2.prototype.pushButton = function(_index) {
        OexUtils.playSound(this._selist[_index]);
        this._scores.push(_index);
        if (JSON.stringify(this._scores) == JSON.stringify([1,3,5,3,1])) {
            $gameSwitches.setValue(133, true);
            this.addLazy(10, this.popScene.bind(this));
        }
        this._buttonIndex = _index;
        // this.addLazy(60, this.popScene.bind(this));
    };


    //-----------------------------------------------------------------------------
    // OexScene_Ex3
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex3() {
        this.initialize(...arguments);
    }

    OexScene_Ex3.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex3.prototype.constructor = OexScene_Ex3;

    OexScene_Ex3.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex3.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndexX = 0;
        this._buttonIndexY = 0;
        this._status = [];
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex3.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndexX += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndexX -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndexY -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndexY += 1;
            SoundManager.playCursor();
        }
        this._buttonIndexX = (this._buttonIndexX + 3) % 3;
        this._buttonIndexY = (this._buttonIndexY + 3) % 3;
        if (Input.isTriggered("ok")) {
            this.pushButton();
        }
        if (TouchInput.isPressed()) {
            this.finger_sp.x = TouchInput.x - this.monitor_sp.x;
            this.finger_sp.y = TouchInput.y - this.monitor_sp.y;
            this.checkTouch(this.finger_sp.x, this.finger_sp.y);
        } else {
            this.finger_sp.x = 20 + 30 + 120 * this._buttonIndexX;
            this.finger_sp.y = 100 + 40 + 120 * this._buttonIndexY;
        }
        this.updateButtons();
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex3.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex3.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex3.prototype.createButtons = function() {
        this.monitor_sp = new Sprite();
        this.monitor_sp.bitmap = ImageManager.loadPicture("smartphone00");
        this.monitor_sp.x = Graphics.boxWidth / 2 - 200;
        this.monitor_sp.y = Graphics.boxHeight / 2 - 300;
        this.addChild(this.monitor_sp);
        this._nodesp = [];
        for (let i = 0; i < 3; i++) {
            var line = [];
            for (let j = 0; j < 3; j++) {
                var sp = new Sprite();
                sp.bitmap = ImageManager.loadPicture("login_node00");
                sp.setFrame(0, 0, 120, 120);
                sp.x = 20 + 120 * i;
                sp.y = 100 + 120 * j;
                this.monitor_sp.addChild(sp);
                line.push(sp);
            }
            this._nodesp.push(line);
        }
        this._linesp = [];
        for (let i = 0; i < 9; i++) {
            var sp = new Sprite();
            sp.visible = false;
            this.monitor_sp.addChild(sp);
            this._linesp.push(sp);
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.monitor_sp.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex3.prototype.updateButtons = function() {
        for (let i = 0; i < this._status.length; i++) {
            var _status = this._status[i];
            this._nodesp[_status[0]][_status[1]].setFrame(120, 0, 120, 120);
        }
        for (let i = 0; i < this._status.length - 1; i++) {
            var _status = this._status[i];
            var _next_status = this._status[i+1];
            var sp = this._linesp[i];
            if (sp.visible) {
                continue;
            }
            sp.x = 20 + 60 + 120 * _status[0];
            sp.y = 100 + 60 + 120 * _status[1];
            var slip_x = _next_status[0] - _status[0];
            var slip_y = _next_status[1] - _status[1];
            if (slip_x == -1) {
                if (slip_y == -1) {
                    sp.bitmap = ImageManager.loadPicture("login_line00");
                    sp.anchor.x = 1.0;
                    sp.anchor.y = 1.0;
                    sp.visible = true;
                } else if (slip_y == 0) {
                    sp.bitmap = ImageManager.loadPicture("login_line03");
                    sp.anchor.x = 1.0;
                    sp.anchor.y = 0.5;
                    sp.visible = true;
                } else if (slip_y == 1) {
                    sp.bitmap = ImageManager.loadPicture("login_line01");
                    sp.anchor.x = 1.0;
                    sp.anchor.y = 0.0;
                    sp.visible = true;
                }
            } else if (slip_x == 0) {
                if (slip_y == -1) {
                    sp.bitmap = ImageManager.loadPicture("login_line02");
                    sp.anchor.x = 0.5;
                    sp.anchor.y = 1.0;
                    sp.visible = true;
                } else if (slip_y == 0) {
                } else if (slip_y == 1) {
                    sp.bitmap = ImageManager.loadPicture("login_line02");
                    sp.anchor.x = 0.5;
                    sp.anchor.y = 0.0;
                    sp.visible = true;
                }
            } else if (slip_x == 1) {
                if (slip_y == -1) {
                    sp.bitmap = ImageManager.loadPicture("login_line01");
                    sp.anchor.x = 0.0;
                    sp.anchor.y = 1.0;
                    sp.visible = true;
                } else if (slip_y == 0) {
                    sp.bitmap = ImageManager.loadPicture("login_line03");
                    sp.anchor.x = 0.0;
                    sp.anchor.y = 0.5;
                    sp.visible = true;
                } else if (slip_y == 1) {
                    sp.bitmap = ImageManager.loadPicture("login_line00");
                    sp.anchor.x = 0.0;
                    sp.anchor.y = 0.0;
                    sp.visible = true;
                }
            }
        }
    };

    OexScene_Ex3.prototype.checkTouch = function(touchX, touchY) {
        for (let i = 0; i < 3; i++) {
            for (let j = 0; j < 3; j++) {
                var cx = 20 + 60 + 120 * i;
                var cy = 100 + 60 + 120 * j;
                if ((touchX - cx) * (touchX - cx) + (touchY - cy) * (touchY - cy) < 900) {
                    if (this.checkButton(i, j)) {
                        this._buttonIndexX = i;
                        this._buttonIndexY = j;
                        this.pushButton();
                    }
                    return;
                }
            }
        }
    };

    OexScene_Ex3.prototype.checkButton = function(newX, newY) {
        if (this._status.length < 9) {
            for (const _status of this._status) {
                if (_status[0] == newX && _status[1] == newY) {
                    return false;
                }
            }
            if (this._status.length > 0) {
                var _status = this._status[this._status.length - 1];
                if (_status[0] < newX - 1 || _status[0] > newX + 1) {
                    return false;
                }
                if (_status[1] < newY - 1 || _status[1] > newY + 1) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };

    OexScene_Ex3.prototype.pushButton = function() {
        if (this._status.length < 9) {
            if (this.checkButton(this._buttonIndexX, this._buttonIndexY)) {
                OexUtils.playSound("__button71");
                this._status.push([this._buttonIndexX, this._buttonIndexY]);
                if (this._status.length == 8) {
                    if (this._status[0][0] == 0 && this._status[0][1] == 0 &&
                        this._status[1][0] == 1 && this._status[1][1] == 0 &&
                        this._status[2][0] == 0 && this._status[2][1] == 1 &&
                        this._status[3][0] == 1 && this._status[3][1] == 1 &&
                        this._status[4][0] == 2 && this._status[4][1] == 0 &&
                        this._status[5][0] == 2 && this._status[5][1] == 1 &&
                        this._status[6][0] == 1 && this._status[6][1] == 2 &&
                        this._status[7][0] == 0 && this._status[7][1] == 2) {
                        OexUtils.playSound("__button02");
                        $gameSwitches.setValue(107, true);
                        this.addLazy(60, this.popScene.bind(this));
                    }
                }
            }
        } else {
            OexUtils.playSound("__button02");
            this.addLazy(60, this.popScene.bind(this));
        }
    };

    OexScene_Ex3.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex4
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex4() {
        this.initialize(...arguments);
    }

    OexScene_Ex4.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex4.prototype.constructor = OexScene_Ex4;

    OexScene_Ex4.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex4.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndexX = 0;
        this._buttonIndexY = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex4.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndexX += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndexX -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndexY -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndexY += 1;
            SoundManager.playCursor();
        }
        this._buttonIndexX = (this._buttonIndexX + 7) % 7;
        this._buttonIndexY = (this._buttonIndexY + 5) % 5;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndexX, this._buttonIndexY);
        }
        if (this._buttonIndexY < 4) {
            this.finger_sp.x = Graphics.boxWidth / 2 - 350 + 50 + this._buttonIndexX * 100;
            this.finger_sp.y = 100 + 50 + 100 * this._buttonIndexY;
        } else {
            this.finger_sp.x = Graphics.boxWidth / 2;
            this.finger_sp.y = 600;
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex4.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex4.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex4.prototype.createButtons = function() {
        this._toggles = [];
        for (let i = 0; i < 7; i++) {
            var _frames = [];
            _frames.push(new Rectangle(0, 0, 100, 100));
            if (i == 0) {
                _frames.push(new Rectangle(300, 0, 100, 100));
            } else if (i == 6) {
                _frames.push(new Rectangle(200, 0, 100, 100));
            } else {
                _frames.push(new Rectangle(100, 0, 100, 100));
            }
            var tmp = [];
            for (let j = 0; j < 4; j++) {
                const ci = i;
                const cj = j;
                var sp = new OexSpriteToggleButton("safe_button00", _frames);
                sp.x = Graphics.boxWidth / 2 - 350 + i * 100;
                sp.y = 100 + 100 * j;
                sp.setClickHandler(this.setButtonIndex.bind(this, ci, cj));
                this.addChild(sp);
                tmp.push(sp);
            }
            this._toggles.push(tmp);
        }
        this._decision = new OexSprite_CommonButton("white_buttons00", new Rectangle(0, 0, 200, 100), new Rectangle(0, 100, 200, 100));
        this._decision.x = Graphics.boxWidth / 2 - 100;
        this._decision.y = 550;
        this._decision.setClickHandler(this.pushButton.bind(this, 0, 4));
        this.addChild(this._decision);
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex4.prototype.setButtonIndex = function(_indexx, _indexy) {
        this._buttonIndexX = _indexx;
        this._buttonIndexY = _indexy;
    };

    OexScene_Ex4.prototype.pushButton = function(_indexX, _indexY) {
        if (_indexY < 4) {
            this._toggles[_indexX][_indexY].onClick();
        } else {
            OexUtils.playSound("__button02");
            var _status = this.getButtonStatus();
            if (JSON.stringify(_status) == JSON.stringify([1,4,12,14,17,22,28])) {
                $gameSwitches.setValue(109, true);
            }
            this.addLazy(10, this.popScene.bind(this));
        }
    };

    OexScene_Ex4.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex4.prototype.getButtonStatus = function() {
        _states = [];
        for (let dt = 0; dt < 28; dt++) {
            var ix = dt % 7;
            var iy = Math.floor(dt / 7);
            if (this._toggles[ix][iy]._state == 1) {
                _states.push(dt + 1);
            }
        }
        return _states;
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex8
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex8() {
        this.initialize(...arguments);
    }

    OexScene_Ex8.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex8.prototype.constructor = OexScene_Ex8;

    OexScene_Ex8.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex8.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndexX = 0;
        this._buttonIndexY = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex8.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndexX += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndexX -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndexY -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndexY += 1;
            SoundManager.playCursor();
        }
        this._buttonIndexX = (this._buttonIndexX + 4) % 4;
        this._buttonIndexY = (this._buttonIndexY + 4) % 4;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndexX, this._buttonIndexY);
        }
        if (this._buttonIndexY < 3) {
            this.finger_sp.x = Graphics.boxWidth / 2 - 200 + 50 + this._buttonIndexX * 100;
            this.finger_sp.y = 100 + 50 + 100 * this._buttonIndexY;
        } else {
            this.finger_sp.x = Graphics.boxWidth / 2;
            this.finger_sp.y = 600;
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex8.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex8.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex8.prototype.createButtons = function() {
        this._toggles = [];
        for (let i = 0; i < 4; i++) {
            var _frames = [];
            _frames.push(new Rectangle(0, 0, 100, 100));
            _frames.push(new Rectangle(100, 0, 100, 100));
            var tmp = [];
            for (let j = 0; j < 3; j++) {
                const ci = i;
                const cj = j;
                var sp = new OexSpriteToggleButton("brown_button00", _frames);
                sp.x = Graphics.boxWidth / 2 - 200 + i * 100;
                sp.y = 100 + 100 * j;
                sp.setClickHandler(this.setButtonIndex.bind(this, ci, cj));
                this.addChild(sp);
                tmp.push(sp);
            }
            this._toggles.push(tmp);
        }
        this._decision = new OexSprite_CommonButton("white_buttons00", new Rectangle(0, 0, 200, 100), new Rectangle(0, 100, 200, 100));
        this._decision.x = Graphics.boxWidth / 2 - 100;
        this._decision.y = 550;
        this._decision.setClickHandler(this.pushButton.bind(this, 0, 3));
        this.addChild(this._decision);
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };

    OexScene_Ex8.prototype.setButtonIndex = function(_indexx, _indexy) {
        this._buttonIndexX = _indexx;
        this._buttonIndexY = _indexy;
    };

    OexScene_Ex8.prototype.pushButton = function(_indexX, _indexY) {
        if (_indexY < 3) {
            this._toggles[_indexX][_indexY].onClick();
        } else {
            OexUtils.playSound("__button02");
            var _status = this.getButtonStatus();
            if (JSON.stringify(_status) == JSON.stringify([2,8,9,11])) {
                $gameSwitches.setValue(131, true);
            }
            this.addLazy(10, this.popScene.bind(this));
        }
    };

    OexScene_Ex8.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Ex8.prototype.getButtonStatus = function() {
        _states = [];
        for (let dt = 0; dt < 12; dt++) {
            var ix = dt % 4;
            var iy = Math.floor(dt / 4);
            if (this._toggles[ix][iy]._state == 1) {
                _states.push(dt + 1);
            }
        }
        return _states;
    };

    //-----------------------------------------------------------------------------
    // OexWindow_NameEdit
    //

    function OexWindow_NameEdit() {
        this.initialize(...arguments);
    }

    OexWindow_NameEdit.prototype = Object.create(Window_NameEdit.prototype);
    OexWindow_NameEdit.prototype.constructor = OexWindow_NameEdit;

    OexWindow_NameEdit.prototype.initialize = function(rect) {
        Window_NameEdit.prototype.initialize.call(this, rect);
    };

    OexWindow_NameEdit.prototype.setup = function(actor, maxLength) {
        this._actor = null;
        this._maxLength = maxLength;
        this._name = "";
        this._index = this._name.length;
        this._defaultName = this._name;
    };

    OexWindow_NameEdit.prototype.faceWidth = function() {
        return 0;
    };

    OexWindow_NameEdit.prototype.drawActorFace = function() {
    };

    OexWindow_NameEdit.prototype.back = function() {
        if (this._index > 0) {
            this._index--;
            this._name = this._name.slice(0, this._index);
            this.refresh();
            return true;
        } else {
            SceneManager.pop();
            return false;
        }
    };

    //-----------------------------------------------------------------------------
    // OexWindow_NameInput
    //
    // The window for selecting text characters on the name input screen.

    function OexWindow_NameInput() {
        this.initialize(...arguments);
    }

    OexWindow_NameInput.prototype = Object.create(Window_Selectable.prototype);
    OexWindow_NameInput.prototype.constructor = OexWindow_NameInput;

    OexWindow_NameInput.JAPAN3 =
            [ "Ａ","Ｂ","Ｃ","Ｄ","Ｅ",
              "Ｆ","Ｇ","Ｈ","Ｉ","Ｊ",
              "Ｋ","Ｌ","Ｍ","Ｎ","Ｏ",
              "Ｐ","Ｑ","Ｒ","Ｓ","Ｔ",
              "Ｕ","Ｖ","Ｗ","Ｘ","Ｙ",
              "Ｚ","決定"];

    OexWindow_NameInput.prototype.initialize = function(rect) {
        Window_Selectable.prototype.initialize.call(this, rect);
        this._editWindow = null;
        this._page = 0;
        this._index = 0;
    };

    OexWindow_NameInput.prototype.setEditWindow = function(editWindow) {
        this._editWindow = editWindow;
        this.refresh();
        this.updateCursor();
        this.activate();
    };

    OexWindow_NameInput.prototype.table = function() {
        return [OexWindow_NameInput.JAPAN3];
    };

    OexWindow_NameInput.prototype.maxCols = function() {
        return 10;
    };

    OexWindow_NameInput.prototype.maxItems = function() {
        return OexWindow_NameInput.JAPAN3.length;
    };

    OexWindow_NameInput.prototype.itemWidth = function() {
        return Math.floor((this.innerWidth - this.groupSpacing()) / 10);
    };

    OexWindow_NameInput.prototype.groupSpacing = function() {
        return 24;
    };

    OexWindow_NameInput.prototype.character = function() {
        return this._index < this.maxItems() - 1 ? this.table()[this._page][this._index] : "";
    };

    OexWindow_NameInput.prototype.isPageChange = function() {
        return false;
    };

    OexWindow_NameInput.prototype.isOk = function() {
        return this._index === this.maxItems() - 1;
    };

    OexWindow_NameInput.prototype.itemRect = function(index) {
        const itemWidth = this.itemWidth();
        const itemHeight = this.itemHeight();
        const colSpacing = this.colSpacing();
        const rowSpacing = this.rowSpacing();
        const groupSpacing = this.groupSpacing();
        const col = index % 10;
        const group = Math.floor(col / 5);
        const x = col * itemWidth + group * groupSpacing + colSpacing / 2;
        const y = Math.floor(index / 10) * itemHeight + rowSpacing / 2;
        const width = itemWidth - colSpacing;
        const height = itemHeight - rowSpacing;
        return new Rectangle(x, y, width, height);
    };

    OexWindow_NameInput.prototype.drawItem = function(index) {
        const table = this.table();
        const character = table[this._page][index];
        const rect = this.itemLineRect(index);
        this.drawText(character, rect.x, rect.y, rect.width, "center");
    };

    OexWindow_NameInput.prototype.updateCursor = function() {
        const rect = this.itemRect(this._index);
        this.setCursorRect(rect.x, rect.y, rect.width, rect.height);
    };

    OexWindow_NameInput.prototype.isCursorMovable = function() {
        return this.active;
    };

    OexWindow_NameInput.prototype.cursorDown = function(wrap) {
        if (this._index + 10 < this.maxItems()) {
            this._index = (this._index + 10);
        }
    };

    OexWindow_NameInput.prototype.cursorUp = function(wrap) {
        if (this._index >= 10) {
            this._index = (this._index - 10);
        }
    };

    OexWindow_NameInput.prototype.cursorRight = function(wrap) {
        if (this._index + 1 < this.maxItems()) {
            this._index = (this._index + 1);
        }
    };

    OexWindow_NameInput.prototype.cursorLeft = function(wrap) {
        if (this._index >= 1) {
            this._index = (this._index - 1);
        }
    };

    OexWindow_NameInput.prototype.cursorPagedown = function() {
    };

    OexWindow_NameInput.prototype.cursorPageup = function() {
    };

    OexWindow_NameInput.prototype.processCursorMove = function() {
        const lastPage = this._page;
        Window_Selectable.prototype.processCursorMove.call(this);
        this.updateCursor();
        if (this._page !== lastPage) {
            this.playCursorSound();
        }
    };

    OexWindow_NameInput.prototype.processHandling = function() {
        if (this.isOpen() && this.active) {
            if (Input.isTriggered("shift")) {
                this.processJump();
            }
            if (Input.isRepeated("cancel")) {
                this.processBack();
            }
            if (Input.isRepeated("ok")) {
                this.processOk();
            }
        }
    };

    OexWindow_NameInput.prototype.isCancelEnabled = function() {
        return true;
    };

    OexWindow_NameInput.prototype.processCancel = function() {
        this.processBack();
    };

    OexWindow_NameInput.prototype.processJump = function() {
        if (this._index !== this.maxItems() - 1) {
            this._index = this.maxItems() - 1;
            this.playCursorSound();
        }
    };

    OexWindow_NameInput.prototype.processBack = function() {
        if (this._editWindow.back()) {
            SoundManager.playCancel();
        }
    };

    OexWindow_NameInput.prototype.processOk = function() {
        if (this.character()) {
            this.onNameAdd();
        } else if (this.isPageChange()) {
            this.playOkSound();
            this.cursorPagedown();
        } else if (this.isOk()) {
            this.onNameOk();
        }
    };

    OexWindow_NameInput.prototype.onNameAdd = function() {
        if (this._editWindow.add(this.character())) {
            this.playOkSound();
        } else {
            this.playBuzzerSound();
        }
    };

    OexWindow_NameInput.prototype.onNameOk = function() {
        if (this._editWindow.name() === "") {
            this.playBuzzerSound();
        } else {
            this.playOkSound();
            this.callOkHandler();
        }
    };


    //-----------------------------------------------------------------------------
    // OexWindow_NameInputJa
    //
    // The window for selecting text characters on the name input screen.

    function OexWindow_NameInputJa() {
        this.initialize(...arguments);
    }

    OexWindow_NameInputJa.prototype = Object.create(OexWindow_NameInput.prototype);
    OexWindow_NameInputJa.prototype.constructor = OexWindow_NameInputJa;

    OexWindow_NameInputJa.JAPAN2 =
            [ "あ","い","う","え","お",
              "か","き","く","け","こ",
              "さ","し","す","せ","そ",
              "た","ち","つ","て","と",
              "な","に","ぬ","ね","の",
              "は","ひ","ふ","へ","ほ",
              "ま","み","む","め","も",
              "や","ゆ","よ","わ","ん",
              "ら","り","る","れ","ろ",
              "が","ぎ","ぐ","げ","ご",
              "ざ","じ","ず","ぜ","ぞ",
              "だ","ぢ","づ","で","ど",
              "ば","び","ぶ","べ","ぼ",
              "ぱ","ぴ","ぷ","ぺ","ぽ",
              "っ","決定"];

    OexWindow_NameInputJa.prototype.initialize = function(rect) {
        OexWindow_NameInput.prototype.initialize.call(this, rect);
    };

    OexWindow_NameInputJa.prototype.table = function() {
        return [OexWindow_NameInputJa.JAPAN2];
    };

    OexWindow_NameInputJa.prototype.maxItems = function() {
        return OexWindow_NameInputJa.JAPAN2.length;
    };

    //-----------------------------------------------------------------------------
    // OexScene_Pass
    //

    function OexScene_Pass() {
        this.initialize(...arguments);
    }

    OexScene_Pass.prototype = Object.create(Scene_MenuBase.prototype);
    OexScene_Pass.prototype.constructor = OexScene_Pass;

    OexScene_Pass.prototype.initialize = function() {
        Scene_MenuBase.prototype.initialize.call(this);
    };

    OexScene_Pass.prototype.prepare = function(actorId, maxLength) {
        this._actorId = actorId;
        this._maxLength = maxLength;
    };

    OexScene_Pass.prototype.create = function() {
        Scene_MenuBase.prototype.create.call(this);
        this._actor = $gameActors.actor(this._actorId);
        this.createEditWindow();
        this.createInputWindow();
    };

    OexScene_Pass.prototype.start = function() {
        Scene_MenuBase.prototype.start.call(this);
        this._editWindow.refresh();
    };

    OexScene_Pass.prototype.createEditWindow = function() {
        const rect = this.editWindowRect();
        this._editWindow = new OexWindow_NameEdit(rect);
        this._editWindow.setup(this._actor, this._maxLength);
        this.addWindow(this._editWindow);
    };

    OexScene_Pass.prototype.editWindowRect = function() {
        const inputWindowHeight = this.calcWindowHeight(9, true);
        const padding = $gameSystem.windowPadding();
        const ww = 600;
        const wh = ImageManager.faceHeight + padding * 2;
        const wx = (Graphics.boxWidth - ww) / 2;
        const wy = (Graphics.boxHeight - (wh + inputWindowHeight + 8)) / 2;
        return new Rectangle(wx, wy, ww, wh);
    };

    OexScene_Pass.prototype.createInputWindow = function() {
        const rect = this.inputWindowRect();
        this._inputWindow = new OexWindow_NameInput(rect);
        this._inputWindow.setEditWindow(this._editWindow);
        this._inputWindow.setHandler("ok", this.onInputOk.bind(this));
        this.addWindow(this._inputWindow);
    };

    OexScene_Pass.prototype.inputWindowRect = function() {
        const wx = this._editWindow.x;
        const wy = this._editWindow.y + this._editWindow.height + 8;
        const ww = this._editWindow.width;
        const wh = this.calcWindowHeight(9, true);
        return new Rectangle(wx, wy, ww, wh);
    };

    OexScene_Pass.prototype.onInputOk = function() {
        var pass = this._editWindow.name();
        if (pass == "しろいしか") {
            $gameSwitches.setValue(63, true);
        }
        this.popScene();
    };

    //-----------------------------------------------------------------------------
    // OexScene_PassJa
    //

    function OexScene_PassJa() {
        this.initialize(...arguments);
    }

    OexScene_PassJa.prototype = Object.create(OexScene_Pass.prototype);
    OexScene_PassJa.prototype.constructor = OexScene_PassJa;

    OexScene_PassJa.prototype.initialize = function() {
        OexScene_Pass.prototype.initialize.call(this);
    };

    OexScene_PassJa.prototype.createInputWindow = function() {
        const rect = this.inputWindowRect();
        this._inputWindow = new OexWindow_NameInputJa(rect);
        this._inputWindow.setEditWindow(this._editWindow);
        this._inputWindow.setHandler("ok", this.onInputOk.bind(this));
        this.addWindow(this._inputWindow);
    };

    //-----------------------------------------------------------------------------
    // OexScene_Ex5
    //
    // The superclass of all the menu-type scenes.

    function OexScene_Ex5() {
        this.initialize(...arguments);
    }

    OexScene_Ex5.prototype = Object.create(Scene_Base.prototype);
    OexScene_Ex5.prototype.constructor = OexScene_Ex5;

    OexScene_Ex5.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
    };

    OexScene_Ex5.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this._buttonIndex = 0;
        this._selectedIndex = -1;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Ex5.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        this._buttonIndex = (this._buttonIndex + 5) % 5;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        for (let i = 0; i < 5; i++) {
            var sp = this._booksp[i];
            sp.x = Graphics.boxWidth / 2 - 400 + 200 + this._book_position[i] * 100;
            sp.y = Graphics.boxHeight / 2 + 300;
            if (this._book_position[i] == this._selectedIndex) {
                sp.opacity = 128;
            } else {
                sp.opacity = 255;
            }
        }
        this.finger_sp.x = Graphics.boxWidth / 2 - 400 + 200 + this._buttonIndex * 100;
        this.finger_sp.y = Graphics.boxHeight / 2;
        this.finger_sp2.x = Graphics.boxWidth / 2 - 400 + 200 + this._selectedIndex * 100;
        this.finger_sp2.y = Graphics.boxHeight / 2;
        this.finger_sp2.visible = (this._selectedIndex >= 0);
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
    };

    OexScene_Ex5.prototype.createBackground = function() {
        this._backgroundFilter = new PIXI.filters.BlurFilter();
        this._backgroundSprite = new Sprite();
        this._backgroundSprite.bitmap = SceneManager.backgroundBitmap();
        this._backgroundSprite.filters = [this._backgroundFilter];
        this.addChild(this._backgroundSprite);
        this.setBackgroundOpacity(192);
    };

    OexScene_Ex5.prototype.setBackgroundOpacity = function(opacity) {
        this._backgroundSprite.opacity = opacity;
    };

    OexScene_Ex5.prototype.createButtons = function() {
        this.back_sp = new Sprite();
        this.back_sp.bitmap = ImageManager.loadPicture("bookback00");
        this.back_sp.x = Graphics.boxWidth / 2 - 400;
        this.back_sp.y = Graphics.boxHeight / 2 - 350;
        this.addChild(this.back_sp);
        this._book_position = [4,2,3,1,0];
        this._booksp = [];
        for (let i = 0; i < 5; i++) {
            var sp = new OexSprite_CommonButton("book0" + (i + 1), new Rectangle(0, 0, 100, 500), new Rectangle(0, 0, 100, 500));
            sp.x = Graphics.boxWidth / 2 - 400 + this._book_position[i] * 100;
            sp.y = Graphics.boxHeight / 2 + 300;
            sp.anchor.x = 0.5;
            sp.anchor.y = 1.0;
            this.addChild(sp);
            this._booksp.push(sp);
            const ci = i;
            sp.setClickHandler(this.pushBook.bind(this, ci));
        }
        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp);
        this.finger_sp2 = new Sprite();
        this.finger_sp2.bitmap = ImageManager.loadPicture("finger");
        this.addChild(this.finger_sp2);
        this.createCancelButton();
    };

    OexScene_Ex5.prototype.pushBook = function(_book_index) {
        this.pushButton(this._book_position[_book_index]);
    };

    OexScene_Ex5.prototype.pushButton = function(_index) {
        OexUtils.playSound("__button45");
        if (_index != this._buttonIndex) {
            this._buttonIndex = _index;
            return;
        }
        if (this._selectedIndex < 0) {
            this._buttonIndex = _index;
            this._selectedIndex = _index;
        } else {
            this._buttonIndex = _index;
            var tmp1 = 0;
            var tmp2 = 0;
            for (let i = 0; i < 5; i++) {
                if (this._book_position[i] == this._buttonIndex) {
                    tmp1 = i;
                    break;
                }
            }
            for (let i = 0; i < 5; i++) {
                if (this._book_position[i] == this._selectedIndex) {
                    tmp2 = i;
                    break;
                }
            }
            this._book_position[tmp1] = this._selectedIndex;
            this._book_position[tmp2] = this._buttonIndex;
            this._selectedIndex = -1;
        }
    };

    OexScene_Ex5.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };



})();
