
    function OexScene_Extra() {
        this.initialize(...arguments);
    }

(() => {
    const pluginName = "plugin_Extra";

    const gallery_info = [
                             { "thums" : 1, "system_key" : "h1_02", "type" : "picture", "images" : ["h1_02","h1_01","h1_03","h1_04","h1_05","h1_06","h1_07","h1_08","h1_10","h1_11","h1_22","h1_24","h1_26"] },
                             { "thums" : 2, "system_key" : "anime_h0102", "type" : "anime", "anime_id" : 21, "repeat" : true },
                             { "thums" : 3, "system_key" : "anime_h0103", "type" : "anime", "anime_id" :  1, "repeat" : true },
                             { "thums" : 4, "system_key" : "anime_h1_omo1", "type" : "anime", "anime_id" :  2, "repeat" : false },
                             { "thums" : 5, "system_key" : "h2_02", "type" : "picture", "images" : ["h2_02","h2_01","h2_05","h2_06","h2_07","h2_08","h2_10","h2_11","h2_21"] },
                             { "thums" : 6, "system_key" : "anime_h0202", "type" : "anime", "anime_id" : 23, "repeat" : true },
                             { "thums" : 7, "system_key" : "anime_h0203", "type" : "anime", "anime_id" :  3, "repeat" : true },
                             { "thums" : 8, "system_key" : "anime_h2_omo1", "type" : "anime", "anime_id" :  4, "repeat" : false },
                             { "thums" : 9, "system_key" : "h5_01", "type" : "picture", "images" : ["h5_01","h5_02","h5_03","h5_04","h5_05","h5_06","h5_07","h5_08","h5_09","h5_10","h5_11","h5_12","h5_13","h5_14","h5_19","h5_20","h5_23"] },
                             { "thums" : 10, "system_key" : "anime_h3_one1", "type" : "anime", "anime_id" : 11, "repeat" : false },
                             { "thums" : 11, "system_key" : "ev_01", "type" : "picture", "images" : ["ev_01"] },
                             { "thums" : 12, "system_key" : "anime_h3_omu3_01", "type" : "anime", "anime_id" : 12, "repeat" : false },
                             { "thums" : 13, "system_key" : "ev_02", "type" : "picture", "images" : ["ev_02","ev_03"] },
                             { "thums" : 14, "system_key" : "anime_h3_omo2", "type" : "anime", "anime_id" :  8, "repeat" : false },
                             { "thums" : 15, "system_key" : "anime_h3_omu2", "type" : "anime", "anime_id" :  9, "repeat" : false },
                             { "thums" : 16, "system_key" : "anime_h3_omo1", "type" : "anime", "anime_id" :  5, "repeat" : false },
                             { "thums" : 17, "system_key" : "anime_h3_omu1_01", "type" : "anime", "anime_id" :  6, "repeat" : false },
                             { "thums" : 18, "system_key" : "__enemy01", "type" : "picture", "images" : ["__enemy01"] },
                             { "thums" : 19, "system_key" : "_title", "type" : "picture", "images" : ["_title"] },
                             { "thums" : 20, "system_key" : "h3_01", "type" : "picture", "images" : ["h3_01"] },
                             { "thums" : 21, "system_key" : "h7_01", "type" : "picture", "images" : ["h7_01","h7_05","h7_06"] }
                         ];


    const memory_info = [
                             { "thums" : 4, "system_key" : "anime_h1_omo1", "memory" : 1 },
                             { "thums" : 8, "system_key" : "anime_h2_omo1", "memory" : 2 },
                             { "thums" : 10, "system_key" : "anime_h3_one1", "memory" : 3 },
                             { "thums" : 12, "system_key" : "anime_h3_omu3_01", "memory" : 4 },
                             { "thums" : 14, "system_key" : "anime_h3_omo2", "memory" : 5 },
                             { "thums" : 15, "system_key" : "anime_h3_omu2", "memory" : 6 },
                             { "thums" : 16, "system_key" : "anime_h3_omo1", "memory" : 7 },
                             { "thums" : 17, "system_key" : "anime_h3_omu1_01", "memory" : 8 }
                         ];

    //-----------------------------------------------------------------------------
    // OexScene_Extra
    //

    OexScene_Extra.prototype = Object.create(Scene_Base.prototype);
    OexScene_Extra.prototype.constructor = OexScene_Extra;

    OexScene_Extra.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
        this._buttonIndex = 0;
    };

    OexScene_Extra.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Extra.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("down")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        this._buttonIndex = (this._buttonIndex + 3) % 3;
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            SceneManager.goto(Scene_Title);
        }
        for (let i = 0; i < 3; i++) {
            var sp = this._title_buttons[i];
            if (i == this._buttonIndex) {
              sp.scale.x = 7.0 / 6.0;
              sp.scale.y = 11.0 / 10.0;
            } else {
              sp.scale.x = 1.0;
              sp.scale.y = 1.0;
            }
        }
    };

    OexScene_Extra.prototype.createBackground = function() {
    };

    OexScene_Extra.prototype.createButtons = function() {
        var texts = ["Gallery","Playback","All open (Cheat)"];
        this._title_buttons = [];
        for (let i = 0; i < 3; i++) {
            const ci = (i);
            var sp = new OexSprite_CommonButton("title_buttons", new Rectangle(0, 0, 400, 60), new Rectangle(0, 0, 400, 60));
            sp.anchor.x = 0.5;
            sp.anchor.y = 0.5;
            sp.x = Graphics.boxWidth / 2;
            sp.y = 250 + 80 * i;
            sp.setClickHandler(this.pushButton.bind(this, ci));
            this.addChild(sp);
            this._title_buttons.push(sp);
            var sp2 = new Sprite();
            sp2.bitmap = new Bitmap(400, 60);
            sp2.bitmap.fontFace = $gameSystem.mainFontFace();
            sp2.bitmap.outlineColor = "black";
            sp2.bitmap.outlineWidth = 4;
            sp2.bitmap.fontSize = 32;
            sp2.bitmap.drawText(texts[i], 0, 12, 400, 32, "center");
            sp2.anchor.x = 0.5;
            sp2.anchor.y = 0.5;
            sp2.x = Graphics.boxWidth / 2;
            sp2.y = 250 + 80 * i;
            this.addChild(sp2);
        }
        this.createCancelButton();
        DataManager.addSystemdInfo("_title");
    };

    OexScene_Extra.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };
    OexScene_Extra.prototype.pushButton = function(_index) {
        if (this._buttonIndex == _index) {
            switch (this._buttonIndex) {
              case 0:
                //alert("new game");
                OexUtils.playSound("Decision5");
                SceneManager.push(OexScene_Gallery);
                break;
              case 1:
                OexUtils.playSound("Decision2");
                SceneManager.push(OexScene_Memory);
                break;
              case 2:
                OexUtils.playSound("Reflection");
                var _pictures = [];
                for (let i = 0; i < gallery_info.length; i++) {
                    _pictures.push(gallery_info[i].system_key);
                    if (gallery_info[i].type == "picture") {
                        for (let j = 0; j < gallery_info[i].images.length; j++) {
                            _pictures.push(gallery_info[i].images[j]);
                        }
                    }
                }
                for (let i = 0; i < _pictures.length; i++) {
                    DataManager.addSystemdInfo(_pictures[i]);
                }
                DataManager.saveSystemdInfo();
                //SceneManager.push(OexScene_Memory);
                break;
            }
        }
        this._buttonIndex = _index;
        OexUtils.playSound("__button45");
    };
    //-----------------------------------------------------------------------------
    // OexScene_Gallery
    //

    function OexScene_Gallery() {
        this.initialize(...arguments);
    }

    OexScene_Gallery.prototype = Object.create(Scene_Base.prototype);
    OexScene_Gallery.prototype.constructor = OexScene_Gallery;

    OexScene_Gallery.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
        this._pageIndex = 0;
    };

    OexScene_Gallery.prototype.prepare = function(_pageindex) {
        this._pageIndex = _pageindex;
    };

    OexScene_Gallery.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this.thums = "gallery_thumb";
        this._buttonIndex = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Gallery.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        this.updateButtons();
        var before_buttonIndex = this._buttonIndex;
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndex -= 5;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndex += 5;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("pageup")) {
            this.prevPage();
        }
        if (Input.isTriggered("pagedown")) {
            this.nextPage();
        }
        this._buttonIndex = (this._buttonIndex + 10) % 10;
        
        var tmp_index = this._pageIndex * 10 + this._buttonIndex;
        if (tmp_index < gallery_info.length) {
        } else {
            this._buttonIndex = before_buttonIndex;
        }
        
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
        }
        this.finger_sp.x = 200 + 150 * (this._buttonIndex % 5) - 25;
        this.finger_sp.y = 300 + 200 * Math.floor(this._buttonIndex / 5) - 75;
    };

    OexScene_Gallery.prototype.updateButtons = function() {
        for (let i = 0; i < 10; i++) {
            var sp = this.thumb_buttons[i];
            var _index = this._pageIndex * 10 + i;
            if (_index < gallery_info.length) {
                var thums_index = gallery_info[_index].thums;
                sp.visible = true;
                if (DataManager.hasSystemdInfo(gallery_info[_index].system_key) || gallery_info[_index].system_key == "") {
                    sp.setFrame(150 * (thums_index % 6), 150 * Math.floor(thums_index / 6), 150, 150);
                } else {
                    sp.setFrame(0, 0, 150, 150);
                }
            } else {
                sp.visible = false;
            }
        }
        this.next_page_sp.visible = this.hasNextPage();
        this.prev_page_sp.visible = this.hasPrevPage();
    };

    OexScene_Gallery.prototype.createBackground = function() {
    };

    OexScene_Gallery.prototype.createButtons = function() {
        this.thumb_buttons = [];
        for (let i = 0; i < 10; i++) {
            const ci= i;
            var sp = new Sprite_Clickable();
            sp.bitmap = ImageManager.loadPicture("gallery_thumb");
            sp.setFrame(0, 0, 150, 150);
            sp.anchor.x = 0.5;
            sp.anchor.y = 0.5;
            sp.x = 200 + 150 * (i % 5);
            sp.y = 300 + 200 * Math.floor(i / 5);
            sp.onClick = this.pushButton.bind(this, ci);
            this.addChild(sp);
            this.thumb_buttons.push(sp);
        }
        this.prev_page_sp = new OexSprite_CommonButton("page_arrow00", new Rectangle(0, 0, 50, 100), new Rectangle(0, 0, 50, 100));
        this.prev_page_sp.x = 10;
        this.prev_page_sp.y = 300;
        this.prev_page_sp.setClickHandler(this.prevPage.bind(this));
        this.addChild(this.prev_page_sp);
        this.next_page_sp = new OexSprite_CommonButton("page_arrow00", new Rectangle(50, 0, 50, 100), new Rectangle(50, 0, 50, 100));
        this.next_page_sp.x = Graphics.boxWidth - 60;
        this.next_page_sp.y = 300;
        this.next_page_sp.setClickHandler(this.nextPage.bind(this));
        this.addChild(this.next_page_sp);

        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("cursor_eye");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };
    

    OexScene_Gallery.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Gallery.prototype.hasNextPage = function() {
        if ((this._pageIndex + 1) * 10 < gallery_info.length) {
            return true;
        }
        return false;
    };

    OexScene_Gallery.prototype.nextPage = function() {
        if (this.hasNextPage()) {
            this._pageIndex += 1;
        }
    };

    OexScene_Gallery.prototype.hasPrevPage = function() {
        if (this._pageIndex > 0) {
            return true;
        }
        return false;
    };

    OexScene_Gallery.prototype.prevPage = function() {
        if (this.hasPrevPage()) {
            this._pageIndex -= 1;
        }
    };

    OexScene_Gallery.prototype.pushButton = function(ci) {
        this._buttonIndex = ci;
        var _index = this._pageIndex * 10 + this._buttonIndex;
        if (_index < gallery_info.length) {
            if (DataManager.hasSystemdInfo(gallery_info[_index].system_key)) {
                OexUtils.playSound("__button02");
                if (gallery_info[_index].type == "picture") {
                    SceneManager.push(OexScene_GalleryPicture);
                    SceneManager.prepareNextScene(_index, this._pageIndex);
                } else if (gallery_info[_index].type == "anime") {
                    SceneManager.push(OexScene_GalleryAnime);
                    SceneManager.prepareNextScene(_index, this._pageIndex);
                }
            }
        }
    };

    //-----------------------------------------------------------------------------
    // OexScene_GalleryPicture
    //

    function OexScene_GalleryPicture() {
        this.initialize(...arguments);
    }

    OexScene_GalleryPicture.prototype = Object.create(Scene_Base.prototype);
    OexScene_GalleryPicture.prototype.constructor = OexScene_GalleryPicture;

    OexScene_GalleryPicture.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
        this._picid = 0;
        this._pageIndex = 0;
        this._index = 0;
        this._pictures = [];
    };

    OexScene_GalleryPicture.prototype.prepare = function(_picid, _pageindex) {
        this._picid = _picid;
        this._pageIndex = _pageindex;
        this._index = 0;
    };

    OexScene_GalleryPicture.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_GalleryPicture.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("ok")) {
            this.pushButton();
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            this.popScene();
            SceneManager.prepareNextScene(this._pageIndex);
        }
    };

    OexScene_GalleryPicture.prototype.createBackground = function() {
    };

    OexScene_GalleryPicture.prototype.createButtons = function() {
        this._pictures = gallery_info[this._picid].images;
        var sp = new Sprite_Clickable();
        sp.bitmap = ImageManager.loadPicture(this._pictures[0]);
        sp.anchor.x = 0.5;
        sp.anchor.y = 0.5;
        sp.x = Graphics.boxWidth / 2;
        sp.y = 720 / 2;
        sp.onClick = this.pushButton.bind(this);
        this.addChild(sp);
        this._mainsp = sp;
        this.createCancelButton();

        var count = 0;
        for (const pic of this._pictures) {
            if (DataManager.hasSystemdInfo(pic)) {
                count += 1;
            }
        }
        var sp2 = new Sprite_Clickable();
        sp2.bitmap = new Bitmap(120, 48);
        sp2.bitmap.drawText("" + count + "/" + this._pictures.length, 0, 0, 120, 48, "center");
        sp2.anchor.x = 0.5;
        sp2.anchor.y = 0.5;
        sp2.x = Graphics.boxWidth / 2;
        sp2.y = 650
        sp2.onClick = this.pushLabel.bind(this);
        this._labelsp = sp2;
        this.addChild(sp2);
    };

    OexScene_GalleryPicture.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_GalleryPicture.prototype.pushButton = function(ci) {
        OexUtils.playSound("__button02");
        this.nextpic();
    };

    OexScene_GalleryPicture.prototype.pushLabel = function(ci) {
        this._labelsp.visible = false;
    };

    OexScene_GalleryPicture.prototype.nextpic = function() {
        this._index += 1;
        this._index = this._index % this._pictures.length;
        var pic = this._pictures[this._index];
        if (DataManager.hasSystemdInfo(pic)) {
            this._mainsp.bitmap = ImageManager.loadPicture(this._pictures[this._index]);
        } else {
            this.nextpic();
        }
    };


    Scene_Base.prototype.isAutosaveEnabled = function() {
        return (
            !$gameSwitches.value(4) &&
            !DataManager.isBattleTest() &&
            !DataManager.isEventTest() &&
            $gameSystem.isAutosaveEnabled() &&
            $gameSystem.isSaveEnabled()
        );
    };

    // Return to Title Screen
    Game_Interpreter.prototype.command354 = function() {
        if ($gameSwitches.value(4)) {
            SceneManager.goto(OexScene_Memory);
        } else {
            SceneManager.goto(Scene_Title);
            DataManager.saveSystemdInfo();
        }
        return true;
    };
    //-----------------------------------------------------------------------------
    // OexScene_GalleryAnime
    //

    function OexScene_GalleryAnime() {
        this.initialize(...arguments);
    }

    OexScene_GalleryAnime.prototype = Object.create(Scene_Base.prototype);
    OexScene_GalleryAnime.prototype.constructor = OexScene_GalleryAnime;

    OexScene_GalleryAnime.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
        this._picid = 0;
        this._pageIndex = 0;
    };

    OexScene_GalleryAnime.prototype.prepare = function(_picid, _pageindex) {
        this._picid = _picid;
        this._pageIndex = _pageindex;
    };

    OexScene_GalleryAnime.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
        $gameSystem.saveBgm();
        AudioManager.stopBgm();
    };

    OexScene_GalleryAnime.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        if (Input.isTriggered("ok")) {
            if ($gameTemp.video_state == "loading") {
            } else if ($gameTemp.video_state == "playing") {
                this.pushPause();
            } else {
                if (this._videoSprite.isEnd()) {
                    this.pushBack();
                }
                this.pushPlay();
            }
        }
        if (Input.isTriggered("right")) {
            if ($gameTemp.video_state == "pause") {
                this.pushNext();
            }
        }
        if (Input.isTriggered("left")) {
            if ($gameTemp.video_state == "pause") {
                this.pushPrev();
            }
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            AudioManager.stopSe();
            SoundManager.playCancel();
            this.popScene();
            SceneManager.prepareNextScene(this._pageIndex);
            $gameSystem.replayBgm();
        }
    };

    OexScene_GalleryAnime.prototype.createBackground = function() {
    };

    OexScene_GalleryAnime.prototype.pushPlay = function() {
        this._videoSprite.start();
    };

    OexScene_GalleryAnime.prototype.pushNext = function() {
        this._videoSprite.nextFrame();
    };

    OexScene_GalleryAnime.prototype.pushPrev = function() {
        this._videoSprite.prevFrame();
    };

    OexScene_GalleryAnime.prototype.pushPause = function() {
        this._videoSprite.pause();
    };

    OexScene_GalleryAnime.prototype.pushBack = function() {
        this._videoSprite.goHead();
    };

    OexScene_GalleryAnime.prototype.createButtons = function() {
        this.anime_id = gallery_info[this._picid].anime_id;
        var _video_controller = new Video_Play_Controller();
        this._videoSprite = new OexSprite_Video(_video_controller);
        this._videoSprite.load(this.anime_id);
        this._videoSprite.repeat = gallery_info[this._picid].repeat;
        this.addChild(this._videoSprite);
        $gameTemp.video_command = "";
    
        this.back_sp = new OexSprite_CommonButton("play_icon00", new Rectangle(0, 0, 32, 32), new Rectangle(0, 0, 32, 32));
        this.back_sp.x = Graphics.boxWidth / 2 - 64;
        this.back_sp.y = 50;
        this.back_sp.setClickHandler(this.pushBack.bind(this));
        this.addChild(this.back_sp);

        this.play_sp = new OexSprite_CommonButton("play_icon00", new Rectangle(32, 0, 32, 32), new Rectangle(32, 0, 32, 32));
        this.play_sp.x = Graphics.boxWidth / 2 - 32;
        this.play_sp.y = 50;
        this.play_sp.setClickHandler(this.pushPlay.bind(this));
        this.addChild(this.play_sp);

        this.pause_sp = new OexSprite_CommonButton("play_icon00", new Rectangle(64, 0, 32, 32), new Rectangle(64, 0, 32, 32));
        this.pause_sp.x = Graphics.boxWidth / 2;
        this.pause_sp.y = 50;
        this.pause_sp.setClickHandler(this.pushPause.bind(this));
        this.addChild(this.pause_sp);

        this.next_sp = new OexSprite_CommonButton("play_icon00", new Rectangle(96, 0, 32, 32), new Rectangle(96, 0, 32, 32));
        this.next_sp.x = Graphics.boxWidth / 2 + 32;
        this.next_sp.y = 50;
        this.next_sp.setClickHandler(this.pushNext.bind(this));
        this.addChild(this.next_sp);

        this.prev_sp = new OexSprite_CommonButton("play_icon00", new Rectangle(128, 0, 32, 32), new Rectangle(128, 0, 32, 32));
        this.prev_sp.x = Graphics.boxWidth / 2 + 64;
        this.prev_sp.y = 50;
        this.prev_sp.setClickHandler(this.pushPrev.bind(this));
        this.addChild(this.prev_sp);
    };

    OexScene_GalleryAnime.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    //-----------------------------------------------------------------------------
    // OexScene_Memory
    //

    function OexScene_Memory() {
        this.initialize(...arguments);
    }

    OexScene_Memory.prototype = Object.create(Scene_Base.prototype);
    OexScene_Memory.prototype.constructor = OexScene_Memory;

    OexScene_Memory.prototype.initialize = function() {
        Scene_Base.prototype.initialize.call(this);
        this._pageIndex = 0;
    };

    OexScene_Memory.prototype.prepare = function(_pageindex) {
        this._pageIndex = _pageindex;
    };

    OexScene_Memory.prototype.create = function() {
        Scene_Base.prototype.create.call(this);
        this.thums = "gallery_thumb";
        this._buttonIndex = 0;
        this.createBackground();
        this.createWindowLayer();
        this.createButtons();
    };

    OexScene_Memory.prototype.update = function() {
        Scene_Base.prototype.update.call(this);
        this.updateButtons();
        var before_buttonIndex = this._buttonIndex;
        if (Input.isTriggered("right")) {
            this._buttonIndex += 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("left")) {
            this._buttonIndex -= 1;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("up")) {
            this._buttonIndex -= 5;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("down")) {
            this._buttonIndex += 5;
            SoundManager.playCursor();
        }
        if (Input.isTriggered("pageup")) {
            this.prevPage();
        }
        if (Input.isTriggered("pagedown")) {
            this.nextPage();
        }
        this._buttonIndex = (this._buttonIndex + 10) % 10;
        
        var tmp_index = this._pageIndex * 10 + this._buttonIndex;
        if (tmp_index < memory_info.length) {
        } else {
            this._buttonIndex = before_buttonIndex;
        }
        
        if (Input.isTriggered("ok")) {
            this.pushButton(this._buttonIndex);
        }
        if (Input.isRepeated("cancel") || TouchInput.isCancelled()) {
            SoundManager.playCancel();
            SceneManager.goto(OexScene_Extra);
        }
        this.finger_sp.x = 200 + 150 * (this._buttonIndex % 5) - 25;
        this.finger_sp.y = 300 + 200 * Math.floor(this._buttonIndex / 5) - 75;
    };

    OexScene_Memory.prototype.updateButtons = function() {
        for (let i = 0; i < 10; i++) {
            var sp = this.thumb_buttons[i];
            var _index = this._pageIndex * 10 + i;
            if (_index < memory_info.length) {
                var thums_index = memory_info[_index].thums;
                sp.visible = true;
                if (DataManager.hasSystemdInfo(memory_info[_index].system_key) || memory_info[_index].system_key == "") {
                    sp.setFrame(150 * (thums_index % 6), 150 * Math.floor(thums_index / 6), 150, 150);
                } else {
                    sp.setFrame(0, 0, 150, 150);
                }
            } else {
                sp.visible = false;
            }
        }
        this.next_page_sp.visible = this.hasNextPage();
        this.prev_page_sp.visible = this.hasPrevPage();
    };

    OexScene_Memory.prototype.createBackground = function() {
    };

    OexScene_Memory.prototype.createButtons = function() {
        this.thumb_buttons = [];
        for (let i = 0; i < 10; i++) {
            const ci= i;
            var sp = new Sprite_Clickable();
            sp.bitmap = ImageManager.loadPicture("gallery_thumb");
            sp.setFrame(0, 0, 150, 150);
            sp.anchor.x = 0.5;
            sp.anchor.y = 0.5;
            sp.x = 200 + 150 * (i % 5);
            sp.y = 300 + 200 * Math.floor(i / 5);
            sp.onClick = this.pushButton.bind(this, ci);
            this.addChild(sp);
            this.thumb_buttons.push(sp);
        }
        this.prev_page_sp = new OexSprite_CommonButton("page_arrow00", new Rectangle(0, 0, 50, 100), new Rectangle(0, 0, 50, 100));
        this.prev_page_sp.x = 10;
        this.prev_page_sp.y = 300;
        this.prev_page_sp.setClickHandler(this.prevPage.bind(this));
        this.addChild(this.prev_page_sp);
        this.next_page_sp = new OexSprite_CommonButton("page_arrow00", new Rectangle(50, 0, 50, 100), new Rectangle(50, 0, 50, 100));
        this.next_page_sp.x = Graphics.boxWidth - 60;
        this.next_page_sp.y = 300;
        this.next_page_sp.setClickHandler(this.nextPage.bind(this));
        this.addChild(this.next_page_sp);

        this.finger_sp = new Sprite();
        this.finger_sp.bitmap = ImageManager.loadPicture("cursor_eye");
        this.addChild(this.finger_sp);
        this.createCancelButton();
    };
    

    OexScene_Memory.prototype.createCancelButton = function() {
        this._cancelButton = new Sprite_Button("cancel");
        this._cancelButton.x = Graphics.boxWidth - this._cancelButton.width - 4;
        this._cancelButton.y = this.buttonY();
        this.addWindow(this._cancelButton);
    };

    OexScene_Memory.prototype.hasNextPage = function() {
        if ((this._pageIndex + 1) * 10 < memory_info.length) {
            return true;
        }
        return false;
    };

    OexScene_Memory.prototype.nextPage = function() {
        if (this.hasNextPage()) {
            this._pageIndex += 1;
        }
    };

    OexScene_Memory.prototype.hasPrevPage = function() {
        if (this._pageIndex > 0) {
            return true;
        }
        return false;
    };

    OexScene_Memory.prototype.prevPage = function() {
        if (this.hasPrevPage()) {
            this._pageIndex -= 1;
        }
    };

    OexScene_Memory.prototype.pushButton = function(ci) {
        this._buttonIndex = ci;
        var _index = this._pageIndex * 10 + this._buttonIndex;
        if (_index < memory_info.length) {
            if (DataManager.hasSystemdInfo(memory_info[_index].system_key)) {
                OexUtils.playSound("__button02");
                DataManager.setupNewGame();
                this.fadeOutAll();
                $gameVariables.setValue(6, memory_info[_index].memory);
                $gameSwitches.setValue(4, true);
                SceneManager.goto(Scene_Map);
            }
        }
    };


})();
