

(() => {
    const pluginName = "plugin_SlideMessage";
    const MAX_SLIDER = 10;
    //-----------------------------------------------------------------------------
    // Game_Map
    //

    var Game_Map_setup_org = Game_Map.prototype.setup;
    Game_Map.prototype.setup = function(mapId) {
        Game_Map_setup_org.apply(this, arguments);
        this._slideMessageInfos = [];
        for (var i = 0; i < MAX_SLIDER; i++) {
            this._slideMessageInfos.push({ "label" : "", "iconIndex" : "", "phase" : 0, "count" : 0, "index" : 0, "needdraw" : false });
        }
        this._sliceNewCount = 0;
    };

    var Game_Map_update_org = Game_Map.prototype.update;
    Game_Map.prototype.update = function(sceneActive) {
        Game_Map_update_org.apply(this, arguments);
        this.updateSlideMessageInfos();
        if ($gameTemp.notificationTexts) {
            if ($gameTemp.notificationTexts.length > 0) {
                if (!this.isSlideMessageMoving()) {
                    for (var i = 0; i < this._slideMessageInfos.length; i++) {
                        var smi = this._slideMessageInfos[i];
                        if (smi.phase == 0) {
                            smi.phase = 1;
                            var item = $gameTemp.notificationTexts.shift();
                            //console.log("notification :" + item.text);
                            smi.label = item.text;
                            smi.needdraw = true;
                            smi.iconIndex = item.iconIndex;
                            smi.index = -1;
                            this.updateIndex(1);
                            this._sliceNewCount = 0;
                            break;
                        }
                    }
                }
            }
        }
    };

    Game_Map.prototype.updateIndex = function(diff) {
        for (var i = 0; i < this._slideMessageInfos.length; i++) {
            var smi = this._slideMessageInfos[i];
            if (smi.phase != 0) {
                smi.index += diff;
            }
        }
    };

    Game_Map.prototype.updateSlideMessageInfos = function() {
        this._sliceNewCount += 1;
        if (this._slideMessageInfos) {
            for (var i = 0; i < this._slideMessageInfos.length; i++) {
                var smi = this._slideMessageInfos[i];
                if (smi.phase == 1) {
                    smi.count += 1;
                    if (smi.count >= 60) {
                        smi.phase += 1;
                        smi.count = 0;
                    }
                } else if (smi.phase == 2) {
                    if (this._sliceNewCount >= 120) {
                        smi.phase += 1;
                        smi.count = 0;
                    }
                } else if (smi.phase == 3) {
                    smi.count += 1;
                    if (smi.count >= 60) {
                        //console.log("smi.phase = 0");
                        smi.phase = 0;
                        smi.count = 0;
                        smi.index = 0;
                        smi.needdraw = false;
                    }
                }
            }
        }
    };

    Game_Map.prototype.isSlideMessageMoving = function() {
        if (this._slideMessageInfos) {
            for (var i = 0; i < this._slideMessageInfos.length; i++) {
                var smi = this._slideMessageInfos[i];
                if (smi.phase == 1 || smi.phase == 3) {
                    return true;
                }
            }
        }
        return false;
    };



    var Spriteset_Map_createUpperLayer_org = Spriteset_Map.prototype.createUpperLayer;
    Spriteset_Map.prototype.createUpperLayer = function() {
        Spriteset_Map_createUpperLayer_org.apply(this, arguments);
        this._SlideMessageWindows = [];
        for (var i = 0; i < MAX_SLIDER; i++) {
            var sp = new Sprite();
            sp.bitmap = ImageManager.loadPicture('itemback00');
            sp.x = 920;
            sp.y = 700- 36;
            sp.visible = false;

            var _iconSprite = new Sprite();
            _iconSprite.bitmap = ImageManager.loadSystem('IconSet');
            _iconSprite.setFrame(0, 0, 32, 32);
            _iconSprite.y = 4;
            _iconSprite.x = 7;
            _iconSprite.scale.x = 0.75;
            _iconSprite.scale.y = 0.75;
            sp.addChild(_iconSprite);
            sp._iconSprite = _iconSprite;

            var _textSprite = new Sprite();
            _textSprite.bitmap = new Bitmap(220 - 48, 28);
            _textSprite.bitmap.textColor = '#ffffff';
            _textSprite.bitmap.fontSize = 24;
            _textSprite.y = 4;
            _textSprite.x = 48;
            sp.addChild(_textSprite);
            sp._textSprite = _textSprite;
            this.addChild(sp);
            this._SlideMessageWindows.push(sp);
        }
    };

    var Spriteset_Map_update_org = Spriteset_Map.prototype.update;
    Spriteset_Map.prototype.update = function() {
        Spriteset_Map_update_org.apply(this, arguments);
        if ($gameTemp.notificationTexts) {
            for (var i = 0; i < this._SlideMessageWindows.length; i++) {
                var sp = this._SlideMessageWindows[i];
                var smi = $gameMap._slideMessageInfos[i];
                switch (smi.phase) {
                    case 0:
                        sp.visible = false;
                        sp.opacity = 255;
                        sp.x = 920;
                        sp.y = 700 - 36;
                        break;
                    case 1:
                        if (sp.visible == false || smi.needdraw) {
                            sp._textSprite.bitmap.clear();
                            sp._textSprite.bitmap.drawText("" + smi.label, 0, 0, 220 - 48, 28);
                            sp._iconSprite.setFrame(Math.floor(smi.iconIndex % 16) * 32, Math.floor(smi.iconIndex / 16) * 32, 32, 32);
                            //console.log("new draw :" + smi.label);
                            smi.needdraw = false;
                        }
                        sp.visible = true;
                        sp.opacity = Math.floor(255.0 * smi.count * 1.0 / 60.0);
                        sp.x = 920 - Math.floor(225.0 * smi.count * 1.0 / 60.0);
                        sp.y = 700 - (36 * (smi.index + 1));
                        break;
                    case 2:
                        sp.visible = true;
                        sp.opacity = 255;
                        sp.x = 920 - 225;
                        var target_y = 700 - (36 * (smi.index + 1));
                        if (target_y < sp.y) {
                            sp.y -= 1;
                        } else if (target_y > sp.y) {
                            sp.y += 1;
                        }
                        break;
                    case 3:
                        sp.visible = true;
                        sp.opacity = Math.floor(255.0 * (60.0 - smi.count) * 1.0 / 60.0);
                        sp.x = 920 - Math.floor(225.0 * (60.0 - smi.count) * 1.0 / 60.0);
                        sp.y = 700 - (36 * (smi.index + 1));
                        break;
                }
                
            }
        }
    };
    //Scene_Map.prototype.onAutosaveSuccess = function() {
    //    if ($gameTemp.notificationTexts) {
    //    } else {
    //      $gameTemp.notificationTexts = [];
    //    }
    //    $gameTemp.notificationTexts.push({ "text" : "Autosave", "iconIndex" : 1 });
    //};


    Game_Temp.prototype.addNotificationTexts = function(_text, _iconIndex) {
        if ($gameTemp.notificationTexts) {
        } else {
          $gameTemp.notificationTexts = [];
        }
        $gameTemp.notificationTexts.push({ "text" : _text, "iconIndex" : _iconIndex });
    };


    var Game_Party_gainItem_org = Game_Party.prototype.gainItem;
    Game_Party.prototype.gainItem = function(item, amount, includeEquip) {
        Game_Party_gainItem_org.apply(this, arguments);
        if (amount > 0) {
            OexUtils.playSound("__event00");
            $gameTemp.addNotificationTexts("" + item.name + "", item.iconIndex);
        }
    };


})();
