
/*:
 *
 * @command LoadVideo
 * @desc 
 * @text LoadVideo
 *
 * @arg video
 * @type number
 * @min 0
 * @max 12
 * @default 0
 * @text video
 * @desc video
 *
 * @command StartVideo
 * @desc 
 * @text StartVideo
 *
 * @command StopVideo
 * @desc 
 * @text StopVideo
 *
 *
 */
 
    function OexSprite_Video() {
        this.initialize(...arguments);
    }

    function Video_Play_Controller() {
        this.initialize(...arguments);
    }


(() => {
    const pluginName = "plugin_Video";
    PluginManager.registerCommand(pluginName, "LoadVideo", function(args) {
        $gameTemp.video_command = "load";
        $gameTemp.auto_play_anime = Number(args.video);
        this.setWaitMode("video");
    });
    PluginManager.registerCommand(pluginName, "StartVideo", function(args) {
        $gameTemp.video_command = "start";
        this.setWaitMode("video");
    });
    PluginManager.registerCommand(pluginName, "StopVideo", function(args) {
        $gameTemp.video_command = "stop";
        this.setWaitMode("video");
    });

    // Play Movie
    // Game_Interpreter.prototype.command261 = function(params) {
    //     if ($gameMessage.isBusy()) {
    //         return false;
    //     }
    //     const name = params[0];
    //     this.setWaitMode("video");
    //     return true;
    // };

    //-----------------------------------------------------------------------------
    // Video_Play_Controller
    //

    Video_Play_Controller.prototype.initialize = function() {
        this.video_sprite = null;
    };

    Video_Play_Controller.prototype.setVideoSprite = function(video_sprite) {
        this.video_sprite = video_sprite;
    };

    Video_Play_Controller.prototype.update = function() {
        switch ($gameTemp.video_command) {
            case "load":
              this.video_sprite.load($gameTemp.auto_play_anime);
              $gameTemp.auto_play_anime = null;
              // $gameMap._interpreter.setWaitMode("video");
              break;
            case "start":
              this.video_sprite.start();
              // $gameMap._interpreter.setWaitMode("video");
              break;
            case "stop":
              this.video_sprite.stop();
              break;
            case "pause":
              this.video_sprite.pause();
              break;
            case "resume":
              this.video_sprite.resume();
              // $gameMap._interpreter.setWaitMode("video");
              break;
        }
        $gameTemp.video_command = "";
    };

    //-----------------------------------------------------------------------------
    // OexSprite_Video
    //

    OexSprite_Video.prototype = Object.create(Sprite.prototype);
    OexSprite_Video.prototype.constructor = OexSprite_Video;

    OexSprite_Video.prototype.initialize = function(_video_controller) {
        Sprite.prototype.initialize.call(this);
        this.repeat = false;
        this.video_playing = false;
        this.video_controller = _video_controller;
        this.video_controller.setVideoSprite(this);
        this.frame_count = 0;
        this.frame_count_bk = 0;
        this._video_cells01 = [0];
        this._video_cells02 = [];
        this._video_width = 300;
        this._video_height = 593;
        this._accumulator = 0;
        this._deltaTime = 1.0 / 8.0;
        this._currentTime = performance.now();
        this.x = 960 / 2;
        this.y = 720 - 20;
        this.z = 7;
        this.visible = false;
        this._video_name01 = "";
        this._videoSprite01 = new Sprite();
        this._videoSprite01.anchor.x = 0.5;
        this._videoSprite01.anchor.y = 1;
        this._videoSprite01.visible = false;
        this.addChild(this._videoSprite01);
        this._video_name02 = "";
        this._videoSprite02 = new Sprite();
        this._videoSprite02.anchor.x = 0.5;
        this._videoSprite02.anchor.y = 1;
        this._videoSprite02.visible = false;
        this.addChild(this._videoSprite02);
    };

    OexSprite_Video.prototype.loadConfig = function(_kind) {
        switch (_kind) {
            case 1: // h1我慢
                this._video_name01 = "anime_h0103";
                this._video_cells01 = [0,1,2,3,4,3,2,1,0,5,6,10,11,10,9,8,7,8,9,10,11,10,6,5];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 2: // h1おもらし
                this._video_name01 = "anime_h1_omo1";
                this._video_cells01 = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,14,15,16,17,18,19];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [[1, "__nyolong00"]];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 3: // h2我慢
                this._video_name01 = "anime_h0203";
                this._video_cells01 = [5,6,7,8,9,8,7,6,5,10,11,12,4,3,2,1,0,1,2,3,4,12,11,10];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 4: // h2おもらし
                this._video_name01 = "anime_h2_omo1";
                this._video_cells01 = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,14,15,16,17,18,19];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [[1, "__nyolong00"]];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 5: // h3 true おもらし
                this._video_name01 = "anime_h3_omo1";
                this._video_cells01 = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,11,12,13,14,15,16,17,18,19];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [[1, "__nyolong00"]];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 6: // h3 true おむつ
                this._video_name01 = "anime_h3_omu1_01";
                this._video_cells01 = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9,10,10,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12];
                this._video_name02 = "anime_h3_omu1_02";
                this._video_cells02 = [ 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1];
                this._video_se = [[20, "__nyo__omutu01"]];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 7: // h3 normal おもらし
                this._video_name01 = "anime_h3_omo2";
                this._video_cells01 = [ 0, 1, 2, 3, 4, 5, 6, 5, 4, 3, 4, 5, 6, 5, 4, 3];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [];
                this._video_width = 600;
                this._video_height = 600;
              break;
            case 8: // h3 normal おもらし
                this._video_name01 = "anime_h3_omo2";
                this._video_name02 = "anime_h3_nyo2";
                this._video_cells01 = [3, 4, 5, 6, 5, 4, 3, 7, 8, 8, 8, 8, 9, 9, 9, 9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14];
                this._video_cells02 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 6, 7, 8, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 9,10,11,12];
                this._video_se = [[12, "__nyolong00"]];
                this._video_width = 600;
                this._video_height = 600;
              break;
            case 9: // h3 normal おむつ
                this._video_name01 = "anime_h3_omu2";
                this._video_cells01 = [0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [[7, "__nyo__omutu01"]];
                this._video_width = 600;
                this._video_height = 600;
              break;
            case 11: // h3 normal おねしょ
                this._video_name01 = "anime_h3_one1";
                this._video_name02 = "anime_h3_one2";
                this._video_cells01 = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 2, 2, 1, 1, 0, 0, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19];
                this._video_cells02 = [ 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                this._video_se = [[50, "__nyo_short"]];
                this._video_width = 600;
                this._video_height = 600;
              break;
            case 12: // h3 normal おむつ
                this._video_name01 = "anime_h3_omu3_01";
                this._video_name02 = "anime_h3_omu3_02";
                this._video_cells01 = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9];
                this._video_cells02 = [ 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14, 9, 9, 9, 9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13];
                this._video_se = [[64, "__nyo__omutu01"]];
                this._video_width = 400;
                this._video_height = 600;
              break;
            case 21: // h1我慢
                this._video_name01 = "anime_h0102";
                this._video_cells01 = [5,5,5,4,3,2,1,0,0,0,0,1,2,3,4];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [];
                this._video_width = 300;
                this._video_height = 593;
              break;
            case 23: // h2我慢
                this._video_name01 = "anime_h0202";
                this._video_cells01 = [8,7,6,5,4,3,2,1,0,0,0,0,1,2,3,4,5,6,7,8,8,8];
                this._video_name02 = "";
                this._video_cells02 = [];
                this._video_se = [];
                this._video_width = 300;
                this._video_height = 593;
              break;
        }
        if (this._video_name01) {
            DataManager.addSystemdInfo(this._video_name01);
        }
    };



    OexSprite_Video.prototype.load = function(_video) {
        $gameTemp.video_state = "loading";
        this.loadConfig(Number(_video));
        this._videoSprite01.bitmap = ImageManager.loadPicture(this._video_name01);
        this._videoSprite01.visible = false;
        if (this._video_name02) {
            this._videoSprite02.bitmap = ImageManager.loadPicture(this._video_name02);
            this._videoSprite02.visible = false;
        }
        this.frame_count = 0;
        this.frame_count_bk = 0;
    };

    OexSprite_Video.prototype.isReady = function() {
        if (this._video_name02) {
            return (this._videoSprite01.bitmap.isReady() && this._videoSprite02.bitmap.isReady());
        }
        return (this._videoSprite01.bitmap.isReady());
    };

    OexSprite_Video.prototype.checkLoad = function() {
        if (this.isReady()) {
            this.goHead()
            console.log("video_loaded");
        } else {
            console.log("video_loading");
        }
    };

    OexSprite_Video.prototype.goHead = function() {
        $gameTemp.video_state = "pause";
        this.frame_count = 0;
        this.frame_count_bk = 0;
        this.initSFrameCount();
    };

    OexSprite_Video.prototype.start = function() {
        $gameTemp.video_state = "playing";
        this.initSFrameCount();
    };

    OexSprite_Video.prototype.stop = function() {
        this._video_name01 = "";
        this._video_name02 = "";
        $gameTemp.video_state = "";
    };

    OexSprite_Video.prototype.pause = function() {
        $gameTemp.video_state = "pause";
    };

    OexSprite_Video.prototype.nextFrame = function() {
        if ($gameTemp.video_state == "pause") {
            var currentFrames = this.getFrameNumber(this.frame_count);
            var nextFrames = [currentFrames[0], currentFrames[1]];
            var tmpFrame = this.frame_count;
            while (tmpFrame < this._video_cells01.length) {
                nextFrames = this.getFrameNumber(tmpFrame);
                if (currentFrames[0] == nextFrames[0] && currentFrames[1] == nextFrames[1]) {
                    tmpFrame += 1;
                } else {
                    this.frame_count = tmpFrame;
                    break;
                }
            }
            if (this.repeat && tmpFrame == this._video_cells01.length) {
                tmpFrame = 0;
                while (tmpFrame < this._video_cells01.length) {
                    nextFrames = this.getFrameNumber(tmpFrame);
                    if (currentFrames[0] == nextFrames[0] && currentFrames[1] == nextFrames[1]) {
                        tmpFrame += 1;
                    } else {
                        this.frame_count = tmpFrame;
                        break;
                    }
                }
            }
        }
    };

    OexSprite_Video.prototype.prevFrame = function() {
        if ($gameTemp.video_state == "pause") {
            var currentFrames = this.getFrameNumber(this.frame_count);
            var nextFrames = [currentFrames[0], currentFrames[1]];
            var tmpFrame = this.frame_count;
            while (tmpFrame >= 0) {
                nextFrames = this.getFrameNumber(tmpFrame);
                if (currentFrames[0] == nextFrames[0] && currentFrames[1] == nextFrames[1]) {
                    tmpFrame -= 1;
                } else {
                    this.frame_count = tmpFrame;
                    break;
                }
            }
            if (this.repeat && tmpFrame == -1) {
                tmpFrame = this._video_cells01.length - 1;
                while (tmpFrame >= 0) {
                    nextFrames = this.getFrameNumber(tmpFrame);
                    if (currentFrames[0] == nextFrames[0] && currentFrames[1] == nextFrames[1]) {
                        tmpFrame -= 1;
                    } else {
                        this.frame_count = tmpFrame;
                        break;
                    }
                }
            }
        }
    };

    OexSprite_Video.prototype.resume = function() {
        $gameTemp.video_state = "playing";
        this.initSFrameCount();
    };

    OexSprite_Video.prototype.update = function() {
        Sprite.prototype.update.call(this);
        this.video_controller.update();

        switch ($gameTemp.video_state) {
            case "loading":
              this.checkLoad();
              this.visible = false;
              break;
            case "pause":
              this.initSFrameCount();
              this.updateVisible();
              this.updateVideoSprite(this._videoSprite01, this._video_cells01);
              this.updateVideoSprite(this._videoSprite02, this._video_cells02);
              break;
            case "playing":
              this.updateSFrameCount();
              this.updateVisible();
              this.updateSe();
              this.updateVideoSprite(this._videoSprite01, this._video_cells01);
              this.updateVideoSprite(this._videoSprite02, this._video_cells02);
              if (this.frame_count >= this._video_cells01.length) {
                  if (this.repeat) {
                      this.frame_count = 0;
                  } else {
                      $gameTemp.video_state = "pause";
                  }
              }
              break;
            default:
              this.visible = false;
              this._videoSprite01.visible = false;
              this._videoSprite02.visible = false;
              break;
        }
    };

    OexSprite_Video.prototype.isEnd = function() {
        if (this.frame_count >= this._video_cells01.length) {
            return true;
        }
        return false;
    };

    OexSprite_Video.prototype.updateSe = function() {
        if (this.frame_count_bk < this.frame_count) {
            for (let i = 0; i < this._video_se.length; i++) {
                if (this._video_se[i][0] == this.frame_count) {
                    OexUtils.playSound(this._video_se[i][1]);
                    console.log(this._video_se[i][1]);
                }
            }
            this.frame_count_bk = this.frame_count;
        }
    };

    OexSprite_Video.prototype.updateVisible = function() {
        this._videoSprite01.visible = true;
        if (this._video_name02) {
            this._videoSprite02.visible = true;
        }
        this.visible = true;
    };

    OexSprite_Video.prototype.getFrameNumber = function(_frame_count) {
        var frame_number1 = 0;
        if (this._videoSprite01.bitmap) {
            if (_frame_count < this._video_cells01.length) {
                frame_number1 = this._video_cells01[_frame_count];
            } else {
                frame_number1 = this._video_cells01[this._video_cells01.length - 1];
            }
        }
        var frame_number2 = 0;
        if (this._videoSprite02.bitmap) {
            if (_frame_count < this._video_cells02.length) {
                frame_number2 = this._video_cells02[_frame_count];
            } else {
                frame_number2 = this._video_cells02[this._video_cells02.length - 1];
            }
        }
        return [frame_number1, frame_number2];
    };

    OexSprite_Video.prototype.updateVideoSprite = function(_videoSprite, _video_cells) {
        if (_videoSprite.bitmap) {
            var frame_number = 0;
            if (this.frame_count < _video_cells.length) {
                frame_number = _video_cells[this.frame_count];
            } else {
                frame_number = _video_cells[_video_cells.length - 1];
            }
            var frame_number_x = frame_number % 5;
            var frame_number_y = Math.floor(frame_number / 5);
            _videoSprite.setFrame(frame_number_x * this._video_width, frame_number_y * this._video_height, this._video_width, this._video_height);
        }
    };

    OexSprite_Video.prototype.initSFrameCount = function() {
        this._accumulator = 0;
        this._currentTime = performance.now();
    };

    OexSprite_Video.prototype.updateSFrameCount = function() {
        var newTime = performance.now();
        var fTime = (newTime - this._currentTime) / 1000;
        if (fTime > 0.25) fTime = 0.25;
        this._currentTime = newTime;
        this._accumulator += fTime;
        while (this._accumulator >= this._deltaTime) {
            this.frame_count += 1;
            this._accumulator -= this._deltaTime;
        }
    };

    var Spriteset_Map_createShadow_org = Spriteset_Map.prototype.createShadow;
    Spriteset_Map.prototype.createShadow = function() {
        Spriteset_Map_createShadow_org.apply(this, arguments);
        var _video_controller = new Video_Play_Controller();
        this._videoSprite = new OexSprite_Video(_video_controller);
        this.addChild(this._videoSprite);
        $gameTemp.video_command = "";
    };

     //  waiting = Video.isPlaying();
    Video.isPlaying = function() {
        return ($gameTemp.video_state == "playing" || $gameTemp.video_state == "loading" || $gameTemp.video_command != "");
    };


})();
