


(() => {
    const pluginName = "plugin_uis";


DataManager._systemInfo = null;

DataManager.loadSystemdInfo = function() {
    StorageManager.loadObject("systemd")
        .then(systemInfo => {
            this._systemInfo = systemInfo;
            return 0;
        })
        .catch(() => {
            this._systemInfo = [];
        });
};

DataManager.saveGlobalInfo = function() {
    StorageManager.saveObject("global", this._globalInfo);
    StorageManager.saveObject("systemd", this._systemInfo);
};

DataManager.saveSystemdInfo = function() {
    StorageManager.saveObject("systemd", this._systemInfo);
};

DataManager.addSystemdInfo = function(key) {
    if (!this._systemInfo.includes(key)) {
        this._systemInfo.push(key);
    }
};

DataManager.hasSystemdInfo = function(key) {
    return this._systemInfo.includes(key);
};


Scene_Boot.prototype.loadPlayerData = function() {
    DataManager.loadSystemdInfo();
    DataManager.loadGlobalInfo();
    ConfigManager.load();
};

})();
